*DECK B1BETA
      DOUBLE PRECISION FUNCTION B1BETA(IAPROX,B2,SIG,DD)
*
*-----------------------------------------------------------------------
*
* COMPITE THE BETA FUNCTION BOR A P1 OR B1 CALCULATION.
*
* INPUT PARAMETERS:
*  IAPROX  : =0: LKRD   =1: P0 OR P1    =2: B0 OR B1
*  B2      : BUCKLING.
*  SIG     : TOTAL MACROSCOPIC CROSS SECTION.
*  DD      : LEAKAGE COEFFICIENT (USED IF IAPROX=0).
*
* OUTPUT PARAMETER:
*  B1BETA  : VALUE OF THE BETA FUNCTION.
*
*-------------------------------------- AUTHOR: A. HEBERT 17/01/91 -----
*
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER HSMG*131
      SIG2=SIG*SIG
      IF (IAPROX.EQ.0) THEN
*        LKRD APPROXIMATION (IMPOSED DIFFUSION COEFFICIENT).
         B1BETA=DD/(SIG+DD*B2)
      ELSE IF (IAPROX.EQ.1) THEN
*        P0 OR P1 APPROXIMATION
         B1BETA=1.0D0/(3.0D0*SIG2+B2)
      ELSE IF (IAPROX.EQ.2) THEN
*        B0 OR B1 APPROXIMATION
         IF (B2.GT.0.05D0*SIG2) THEN
            TMP=SQRT(B2)/SIG
            B1BETA=(1.0D0-ATAN(TMP)/TMP)/B2
         ELSE IF ((B2.LT.-0.05D0*SIG2).AND.(B2.GE.-0.995D0*SIG2)) THEN
            TMP=SQRT(-B2)
            B1BETA=(1.0D0-0.5D0*SIG*LOG((SIG+TMP)/(SIG-TMP))/TMP)/B2
         ELSE IF((B2.LE.0.05D0*SIG2).AND.(B2.GE.-0.05D0*SIG2)) THEN
            TMP=B2/SIG2
            B1BETA=(1.0D0-3.0D0*TMP*(0.2D0-TMP/7.0D0+TMP*TMP/9.0D0-TMP
     1      *TMP*TMP/11.0D0))/(3.0D0*SIG2)
         ELSE
            WRITE(HSMG,'(22HB1BETA: THE BUCKLING (,1P,E12.4,8H) IS SMA,
     1      9HLLER THAN,E12.4,1H.)') B2,-0.995D0*SIG2
            CALL XABORT(HSMG)
         ENDIF
      ELSE
         CALL XABORT('B1BETA: INVALID VALUE OF IAPROX.')
      ENDIF
      RETURN
      END
