*DECK CPODRV
      SUBROUTINE CPODRV(IPCPO ,IPEDIT,IPDEPL,IPRINT,CURNAM,CTITRE,
     >                  NAMCPO,NGROUP,NMERGE,NBMICR,NIFISS,MXBURN,
     >                  NL    ,NISCPO,NPROC ,ILEAKS,NXXXZ,
     >                  ITRANC,NEDMAC,HVECT ,IEXTRC,NSBS  ,
     >                  ISOCPO,ISOFIS,MIXFIS,ISOTMP,IMXTMP,IDIMIX,
     >                  NBIMRG,ICOMIX,VOLMER,ENERGY,INDPRO,ITYPRO,
     >                  TIME  ,BURN  ,WIRRAD,DENCPO,DENTMP,DXSMIC,
     >                  DSCMIC,DXSMAC,DSCMAC,IBSTEP,EMJTMP,EMJMAC,
     >                  DMJCPO,DISFAC)
C
C-----------------------------------------------------------------------
C
C RECOVER CROSS SECTION INFORMATION LOCATED ON DIRECTORY CURNAM OR ON
C DIRECTORY FAMILY WITH PREFIX CURNAM.
C
C INPUT PARAMETERS:
C  IPCPO   : POINTER TO THE COMPO (L_COMPO SIGNATURE).
C  IPEDIT  : POINTER TO EDIT INFORMATION (L_EDIT SIGNATURE).
C  IPDEPL  : POINTER TO DEPLETION INFORMATION (L_BURNUP SIGNATURE).
C  IPRINT  : PRINT PARAMETER. EQUAL TO ZERO FOR NO PRINT.
C  CURNAM  : NAME OF THE OUTPUT DIRECTORY (OR PREFIX OF OUTPUT DIREC-
C            TORY IN BURNUP CASES).
C  CTITRE  : CHARACTER*72 TITLE.
C  NAMCPO  : CHARACTER*8 NAME OF THE MATERIAL MIXTURE SUB-DIRECTORY.
C  NGROUP  : NUMBER OF ENERGY GROUPS IN OUTPUT DATA.
C  NMERGE  : NUMBER OF OUTPUT REGIONS.
C  NBMICR  : MAXIMUM NUMBER OF ISOTOPES
C  NIFISS  : NUMBER OF FISSILE ISOTOPES
C  MXBURN  : MAXIMUM NUMBER OF OUTPUT BURNUP SETS.
C  NL      : NUMBER OF LEGENDRE ORDERS. =1 FOR ISOTROPIC SCATTERING.
C  NISCPO  : NUMBER OF CPO ISOTOPES TREATED
C  NPROC   : NUMBER OF MICROSCOPIC XS TO PROCESS.
C  ILEAKS  : LEAK OPTION -> 0 NO LEAKAGE ; 1 SURFACE LEAKAGE ;
C            2 HOMOGENEOUS LEAKAGE ;  3 HETEROGENEOUS LEAKAGE
C  NXXXZ   : MAXIMUM DIMENSION OF ISO DEPENDENT VECTOR
C            =MAX(NBMICR,1)
C  ITRANC  : TYPE OF TRANSPORT CORRECTION IN THE COMPO.
C  NEDMAC  : NUMBER OF EDIT XS.
C  HVECT   : NAME OF EDIT XS. CHARACTER HVECT(NEDMAC)*8
C  IEXTRC  : TYPE OF EXTRACTION: 0 FOR NONE, 1 FOR PART 2 FOR ALL
C  NSBS    : NUMBER OF SUB-BURNUP STEP CONSIDERED
C  ISOCPO  : CPO NAME OF ISOTOPES ISOCPO(3,NXXXZ)
C  ISOFIS  : NAME OF FISSILE ISOTOPES ISOFIS(2,(NIFISS+1))
C  MIXFIS  : MATERIAL OF FISSILE ISOTOPES MIXFIS(NMERGE,(NIFISS+1))
C  ISOTMP  : NAME OF ISOTOPES IN EDIT ISOTMP(3,NXXXZ)
C  IMXTMP  : MIXTURE OF ISOTOPES IN EDIT IMXTMP(NXXXZ)
C  IDIMIX  : ISOTOPES IDENTIFIER IN EACH CPO MATERIAL
C            IDIMIX(NMERGE,NXXXZ)
C  NBIMRG  : FINAL NUMBER OF ISOTOPE PER REGION
C            NBIMRG(NMERGE)
C  ICOMIX  : POINTER TO CPO ISOTOPE FOR REGION
C            ICOMIX(NMERGE,NXXXZ)
C  VOLMER  : MERGE VOLUME VOLMER(NMERGE)
C  ENERGY  : ENERGY ENERGY(NGROUP+1)
C  INDPRO  : IDENTIFIER FOR XS PROCESSING INDPRO(NPROC)
C  ITYPRO  : IDENTIFIER FOR XS PROCESSED ITYPRO(NPROC)
C  TIME    : TIME STEPS TIME(MXBURN)
C  BURN    : BURNUP BURN(MXBURN)
C  WIRRAD  : IRRADIATION WIRRAD(MXBURN)
C  DENCPO  : DENSITY OF CPO ISOTOPES
C            DOUBLE PRECISION DENCPO(NXXXZ)
C  DENTMP  : DENSITY OF EDI ISOTOPES
C            REAL DENTMP(NXXXZ)
C  DXSMIC  : MICRO VECTOR XS
C            DOUBLE PRECISION DXSMIC(NGROUP,NPROC)
C  DSCMIC  : MICRO SCAT MATRIX XS
C            DOUBLE PRECISION DSCMIC(NGROUP,NGROUP,NL)
C  DXSMAC  : MACRO VECTOR XS
C            DOUBLE PRECISION DXSMAC(NGROUP,NPROC,NMERGE)
C  DSCMAC  : MACRO SCAT MATRIX XS
C            DOUBLE PRECISION DSCMAC(NGROUP,NGROUP,NL,NMERGE)
C  IBSTEP  : SUB-BURNUP STEP CONSIDERED - INTEGER IBSTEP(MXBURN)
C  EMJTMP  : FISSION ENERGY PER ISOTOPES - REAL EMJTMP(NXXXZ)
C  EMJMAC  : FISSION ENERGY FOR MACRO - REAL EMJMAC(NMERGE)
C  DMJCPO  : FISSION ENERGY FOR MACRO -
C            DOUBLE PRECISION DMJCPO(2,NXXXZ)
C  DISFAC  : DISCONTINUITY FACTORS              D(2,NGROUP,3)
C
C------------------------------------ AUTHOR: A. HEBERT   ; 02/02/93 ---
C---------------------------------- MODIFIED: T. SISSAOUI ; 97/07/10 ---
C---------------------------------- MODIFIED: G. MARLEAU  ; 97/07/10 ---
C
      IMPLICIT         NONE
      INTEGER          IPCPO ,IPEDIT,IPDEPL,IPRINT,NGROUP,NMERGE,
     >                 CTITRE(18),NBMICR,NIFISS,MXBURN,NL,NISCPO,
     >                 NPROC ,ILEAKS,NXXXZ,ITRANC,NEDMAC,
     >                 IEXTRC,NSBS  ,ISOCPO(3,NXXXZ),
     >                 ISOFIS(2,(NIFISS+1)), MIXFIS(NMERGE,(NIFISS+1)),
     >                 ISOTMP(3,NXXXZ),IMXTMP(NXXXZ),
     >                 IDIMIX(NMERGE,NXXXZ),NBIMRG(NMERGE),
     >                 ICOMIX(NMERGE,NXXXZ),INDPRO(NPROC),
     >                 ITYPRO(NPROC),IBSTEP(MXBURN)
      CHARACTER        CURNAM*12,NAMCPO*8,HVECT(NEDMAC)*8
      REAL             VOLMER(NMERGE),ENERGY(NGROUP+1),
     >                 TIME(MXBURN),BURN(MXBURN),WIRRAD(MXBURN),
     >                 DENTMP(NXXXZ),EMJTMP(NXXXZ),
     >                 EMJMAC(NMERGE)
      DOUBLE PRECISION DENCPO(NXXXZ),DXSMIC(NGROUP,NPROC),
     >                 DSCMIC(NGROUP,NGROUP,NL),
     >                 DXSMAC(NGROUP,NPROC,NMERGE),
     >                 DSCMAC(NGROUP,NGROUP,NL,NMERGE),
     >                 DMJCPO(2,NXXXZ)
      DOUBLE PRECISION DISFAC(2,NGROUP,3)
C----
C  MEMORY ALLOCATION PARAMETERS
C----
      INTEGER          IBASE(1)
      REAL             RBASE
      COMMON           RBASE(1)
      EQUIVALENCE     (RBASE(1),IBASE(1))
      INTEGER          DISTMP
C----
C  LOCAL PARAMETERS
C----
      INTEGER          IOUT,NSTATE,NDPROC,NPARAM
      REAL             CUTOFF
      PARAMETER       (IOUT=6,NSTATE=40,NDPROC=20,NPARAM=4,
     >                 CUTOFF=1.0E5)
      INTEGER          NEFBRN,IBR,IBURN,IVECT,IXSREC,IXSCAT,
     >                 NDUM1,NDUM2,MAXDM,IDISFC,ISCATC,IIJJ,INJJ,
     >                 IMRG,ISOC,ISOR,ITC,IDFLU,IDNUFI,INAMI,IDENSI,
     >                 ISTATE(NSTATE),IPARAM(NPARAM),MXISOS,IEMJI,
     >                 IXSREM,ISCREM
      CHARACTER        NAMMIX*12,NAMBRN*12,NAMISO*12,NAMMAC*12
      REAL             DELTA(2),TMPDAY(3),DELERR(3)
      DOUBLE PRECISION DMJMAC
      INTEGER          IFCDIS
C----
C  GET BURNUP AND IRRADIATION
C----
      IFCDIS=1
      NAMMAC='MACR       '
      IF(NSBS.EQ.0) THEN
        BURN(1)=0.0
        WIRRAD(1)=0.0
        NEFBRN=1
        IBSTEP(NEFBRN)=0
      ELSE
        DO 100 IBR=1,NSBS
          IBURN=IBSTEP(IBR)
          IF(IBURN.GT.0.AND. IBURN.LE.MXBURN) THEN
            WRITE(NAMBRN,'(8HDEPL-DAT,I4.4)') IBURN
            CALL LCMSIX(IPDEPL,NAMBRN,1)
            CALL LCMGET(IPDEPL,'BURNUP-IRRAD',DELTA)
            BURN(IBR)=DELTA(1)
            WIRRAD(IBR)=DELTA(2)
            TIME(IBR)=TIME(IBURN)
            CALL LCMSIX(IPDEPL,NAMBRN,2)
          ELSE
          ENDIF
 100    CONTINUE
        NEFBRN=NSBS
      ENDIF
C----
C  INITIALIZE INDPRO FOR MICROSCOPIC XS TO PROCESS
C----
      CALL SETARA(IBASE,NEDMAC,IVECT)
      CALL XDISET(IBASE(IVECT),NEDMAC,0)
      CALL XDRNED(NPROC ,0,NL-1,MAX(2,ILEAKS),NEDMAC,HVECT,
     >            IBASE(IVECT),INDPRO)
      INDPRO(6)=0
      INDPRO(16)=0
      CALL SETARA(RBASE,NGROUP*NPROC,IXSREC)
      CALL SETARA(RBASE,NGROUP*NGROUP*NL,IXSCAT)
C----
C  LOOP OVER BURNUP STEPS
C----
      NDUM1=NMERGE*MAX(NIFISS,NGROUP)
      NDUM2=NGROUP*NGROUP
      MAXDM=MAX(NDUM1,NDUM2)
      CALL SETARA(RBASE,NGROUP,IDISFC)
      CALL SETARA(RBASE,MAXDM,ISCATC)
      CALL SETARA(IBASE,MAX(NMERGE,NGROUP),IIJJ)
      CALL SETARA(IBASE,MAX(NMERGE,NGROUP),INJJ)
      CALL SETARA(RBASE,2*NGROUP*NPROC,IXSREM)
      CALL SETARA(RBASE,2*NGROUP*NGROUP*NL,ISCREM)
      IDFLU=16
      DO 110 IBR=1,NEFBRN
        WRITE(NAMBRN,'(A8,I4)') 'BURN    ',IBR
        IBURN=IBSTEP(IBR)
        IF(IBURN.GT.0) THEN
          WRITE(CURNAM(9:12),'(I4)') IBURN
        ENDIF
        CALL LCMSIX(IPEDIT,CURNAM,1)
        IF(NISCPO.GT.0) THEN
          CALL LCMGET(IPEDIT,'ISOTOPESDENS',DENTMP)
        ENDIF
        IF(IPRINT.GE.10) THEN
          WRITE(IOUT,6000) CURNAM
        ENDIF
        CALL LCMSIX(IPEDIT,'MACROLIB',1)
        CALL LCMGET(IPEDIT,'TIMESTAMP',TMPDAY)
        DELERR(1)=CUTOFF*ABS(TMPDAY(1)-TIME(IBR)/8.64E-4)
        DELERR(2)=CUTOFF*ABS(TMPDAY(2)-BURN(IBR))
        DELERR(3)=CUTOFF*ABS(TMPDAY(3)-WIRRAD(IBR))
        IF( (DELERR(1).GT.TMPDAY(1)) .OR.
     >      (DELERR(2).GT.TMPDAY(2)) .OR.
     >      (DELERR(3).GT.TMPDAY(3)) ) THEN
          IF(TIME(IBR)   .EQ. 0.0 .AND.
     >       BURN(IBR)   .EQ. 0.0 .AND.
     >       WIRRAD(IBR) .EQ. 0.0) THEN
            WRITE(IOUT,7001)
          ELSE
            WRITE(IOUT,7000)
     >        TMPDAY(1),TIME(IBR)/8.64E-4,DELERR(1)/CUTOFF,
     >        TMPDAY(2),BURN(IBR),DELERR(2)/CUTOFF,
     >        TMPDAY(3),WIRRAD(IBR)      ,DELERR(3)/CUTOFF
          ENDIF
          TIME(IBR)=TMPDAY(1)*8.64E-4
          BURN(IBR)=TMPDAY(2)
          WIRRAD(IBR)=TMPDAY(3)
        ENDIF
C----
C  READ MACROSCOPIC XS FOR ALL GROUP AND ALL REGIONS
C----
        CALL SETARA(RBASE,2*NMERGE*(NIFISS+1),IDNUFI)
        CALL CPOMAR(IPEDIT,NGROUP,NMERGE,NL    ,NIFISS,NEDMAC,
     >              HVECT ,IBASE(IVECT) ,NPROC ,ILEAKS,DXSMAC,
     >              DSCMAC,EMJMAC,RBASE(IDISFC),RBASE(ISCATC),
     >              IBASE(IIJJ),IBASE(INJJ),RBASE(IDNUFI),
     >              IFCDIS,DISFAC)
        CALL RLSARA(RBASE(IDNUFI))
        CALL LCMSIX(IPEDIT,'MACROLIB',2)
        CALL XDDSET(DENCPO,NISCPO,0.0D0)
        MXISOS=0
        DO 120 IMRG=1,NMERGE
          DMJMAC=DBLE(EMJMAC(IMRG))
          WRITE(NAMMIX,'(A8,I4)') NAMCPO,IMRG
          CALL LCMSIX(IPCPO,NAMMIX,1)
          CALL LCMSIX(IPCPO,NAMBRN,1)
          IF(IPRINT.GE.10) THEN
            WRITE(IOUT,6001) NAMMIX
          ENDIF
          CALL XDDSET(DMJCPO,2*NBMICR,0.0D0)
          CALL XDDSET(RBASE(IXSREM),NGROUP*NPROC,0.0D0)
          CALL XDDSET(RBASE(ISCREM),NGROUP*NGROUP*NL,0.0D0)
          DO 130 ISOC=1,NBIMRG(IMRG)
            ISOR=ICOMIX(IMRG,ISOC)
            WRITE(NAMISO,'(3A4)') (ISOCPO(ITC,ISOR),ITC=1,3)
            IF(IPRINT.GE.10) THEN
              WRITE(IOUT,6002) NAMISO
            ENDIF
C----
C   CREATE AND SAVE XS FOR A CPO ISOTOPE IN CURRENT REGION
C----
            CALL LCMSIX(IPCPO,NAMISO,1)
            CALL XDDSET(DXSMIC,NGROUP*NPROC,0.0D0)
            CALL XDDSET(DSCMIC,NGROUP*NGROUP*NL,0.0D0)
            CALL CPOMIC(IPCPO ,IPEDIT,IPRINT,NGROUP,NMERGE,NBMICR,
     >                  NL    ,IMRG  ,ISOR  ,NPROC ,ISOTMP,IDIMIX,
     >                  INDPRO,ITYPRO,DENCPO,DENTMP,DXSMIC,DSCMIC,
     >                  EMJTMP,DMJCPO,DXSMAC(1,IDFLU,IMRG),
     >                  RBASE(IXSREC),RBASE(IXSCAT),
     >                  RBASE(ISCATC),IBASE(IIJJ),IBASE(INJJ))
            CALL LCMSIX(IPCPO,NAMISO,2)
C----
C   REMOVE CONTRIBUTION OF CPO ISOTOPE FROM MACROSCOPIC.
C----
            IF(DENCPO(ISOR).GT.0.0D0) THEN
              CALL CPOREM(NGROUP,NL    ,NPROC ,INDPRO,
     >                    DENCPO(ISOR),DXSMIC,DSCMIC,
     >                    RBASE(IXSREM),RBASE(ISCREM))
            ENDIF
            DMJMAC=DMJMAC-DMJCPO(1,ISOR)
 130      CONTINUE
C----
C  WRITE MACROSCOPIC XS FOR ALL GROUP IN THIS REGION REGIONS
C----
          CALL SETARA(RBASE,2*NGROUP,DISTMP)
          CALL CPOMAW(IPCPO ,NGROUP,NL    ,NPROC ,INDPRO,ITYPRO,
     >                DXSMAC(1,1,IMRG),DSCMAC(1,1,1,IMRG),
     >                RBASE(IXSREM),RBASE(ISCREM),
     >                RBASE(IDISFC),RBASE(IXSREC),RBASE(IXSCAT),
     >                RBASE(ISCATC),IBASE(IIJJ),IBASE(INJJ),DMJMAC,
     >                IFCDIS,DISFAC,RBASE(DISTMP))
          CALL RLSARA(RBASE(DISTMP))
          CALL SETARA(RBASE,(NBIMRG(IMRG)+1),IDENSI)
          CALL SETARA(RBASE,(NBIMRG(IMRG)+1),IEMJI)
          RBASE(IDENSI)=1.0
          RBASE(IEMJI)=DMJMAC*1.0E-18
          DO 140 ISOC=1,NBIMRG(IMRG)
            ISOR=ICOMIX(IMRG,ISOC)
            RBASE(IDENSI+ISOC)=REAL(DENCPO(ISOR))
            IF(DMJCPO(2,ISOR).GT.0.0D0) THEN
              RBASE(IEMJI+ISOC)=1.0E-18*
     >                          REAL(DMJCPO(1,ISOR)/DMJCPO(2,ISOR))
            ELSE
              RBASE(IEMJI+ISOC)=0.0
            ENDIF
 140      CONTINUE
          CALL LCMPUT(IPCPO,'ISOTOPESDENS',(NBIMRG(IMRG)+1),2,
     >                RBASE(IDENSI))
          CALL LCMPUT(IPCPO,'ISOTOPES-EFJ',(NBIMRG(IMRG)+1),2,
     >                RBASE(IEMJI))
          CALL RLSARA(RBASE(IEMJI))
          CALL RLSARA(RBASE(IDENSI))
          CALL LCMSIX(IPCPO,NAMBRN,2)
C----
C  PUT REMAINING INFORMATION ON CPO FOR THIS MIXTURE
C----
          CALL LCMPUT(IPCPO,'TITLE',18,3,CTITRE)
          CALL LCMPUT(IPCPO,'VOLUME',1,2,VOLMER(IMRG))
          CALL LCMPUT(IPCPO,'ENERGY',NGROUP+1,2,ENERGY)
          IF(IBR.EQ.NEFBRN) THEN
            CALL LCMPUT(IPCPO,'BURNUP',NEFBRN,2,BURN)
            CALL LCMPUT(IPCPO,'N/KB  ',NEFBRN,2,WIRRAD)
            CALL SETARA(IBASE,3*(NBIMRG(IMRG)+1),INAMI)
            READ(NAMMAC,'(3A4)') (IBASE(ITC),ITC=INAMI,INAMI+2)
            ITC=INAMI+3
            DO 150 ISOC=1,NBIMRG(IMRG)
              ISOR=ICOMIX(IMRG,ISOC)
              IBASE(ITC)=ISOCPO(1,ISOR)
              IBASE(ITC+1)=ISOCPO(2,ISOR)
              IBASE(ITC+2)=ISOCPO(3,ISOR)
              ITC=ITC+3
 150        CONTINUE
            CALL LCMPUT(IPCPO,'ISOTOPESNAME',3*(NBIMRG(IMRG)+1),3,
     >                  IBASE(INAMI))
            CALL XDISET(IBASE(INAMI),(NBIMRG(IMRG)+1),0)
            CALL LCMPUT(IPCPO,'JTAB',(NBIMRG(IMRG)+1),1,
     >                  IBASE(INAMI))
            CALL RLSARA(IBASE(INAMI))
            CALL XDISET(IPARAM,NPARAM,0)
            IPARAM(1)=NGROUP
            IPARAM(2)=NBIMRG(IMRG)+1
            IPARAM(3)=NL
            IPARAM(4)=NEFBRN
            MXISOS=MAX(MXISOS,NBIMRG(IMRG)+1)
            CALL LCMPUT(IPCPO,'PARAM',NPARAM,1,IPARAM)
          ENDIF
          CALL LCMSIX(IPCPO,NAMMIX,2)
 120    CONTINUE
        CALL LCMSIX(IPEDIT,CURNAM,2)
 110  CONTINUE
      CALL XDISET(ISTATE,NSTATE,0)
      ISTATE(1)=NMERGE
      ISTATE(2)=NGROUP
      ISTATE(3)=MXISOS
      ISTATE(4)=NL
      ISTATE(5)=NEFBRN
      ISTATE(6)=NPARAM
      ISTATE(7)=IFCDIS
      CALL LCMPUT(IPCPO,'STATE-VECTOR',NSTATE,1,ISTATE)
      CALL RLSARA(RBASE(ISCREM))
      CALL RLSARA(RBASE(IXSREM))
      CALL RLSARA(IBASE(INJJ))
      CALL RLSARA(IBASE(IIJJ))
      CALL RLSARA(RBASE(ISCATC))
      CALL RLSARA(RBASE(IDISFC))
      IF(NISCPO.GT.0) THEN
        CALL RLSARA(RBASE(IXSCAT))
        CALL RLSARA(RBASE(IXSREC))
        CALL RLSARA(IBASE(IVECT))
      ENDIF
C----
C  PRINT FORMAT
C----
 6000 FORMAT(' CPODRV: STEPPING UP ON DIRECTORY = ',A12)
 6001 FORMAT(' CPODRV: CREATING MIXTURE         = ',A12)
 6002 FORMAT(' CPODRV: CREATING ISOTOPE         = ',A12)
C----
C  WARNING FORMAT
C----
 7000 FORMAT(
     > ' CPODRV: WARNING -> BURNUP AND EDIT DATA DIFFER',1P/
     > ' TIME: EDIT=',E15.7,5X,' BURNUP=',E15.7,' DIFF=',E15.7/
     > ' BURN: EDIT=',E15.7,5X,' BURNUP=',E15.7,' DIFF=',E15.7/
     > ' WIRR: EDIT=',E15.7,5X,' BURNUP=',E15.7,' DIFF=',E15.7/
     > ' USE EDIT DATA   ')
 7001 FORMAT(
     > ' CPODRV: WARNING -> 0 BURNUP STEP, USE EDIT DATA')
      RETURN
      END
