*DECK EXCELP
      SUBROUTINE EXCELP(  IPSYS, IPTRK, IFTRAK, IPRNTP, NREGIO, NBMIX ,
     >                   MATCOD,VOLUME, NRENOR, NELPIJ, IPIJK , LEAKSW,
     >                   TITREC,XSSIGT,    PIJ,   NSBG, NPST  ,PROBKS ,
     >                   JGL   ,NGROUP, IFUITE,
     >                   NALBP ,ALBP  )
************************************************************************
*                                                                      *
*           NAME: EXCELP                                               *
*      COMPONENT: EXCELL                                               *
*          LEVEL: 1 (CALLED BY "DRAGON" IN 'ASMDRV')                   *
*        VERSION: 1.3                                                  *
*       CREATION: 87/04                                                *
*       MODIFIED: 91/07 (R.R.)                                         *
*                 94/05 (I.P.) PIJK CALCULATION                        *
*                 97/01 (E.V.) HELIOS CP NORMALIZATION                 *
*                 00/03 (R.R.) DECLARE ALL VARIABLE TYPES              *
*         AUTHOR: ROBERT ROY                                           *
*                                                                      *
*     SUBROUTINE: THIS ROUTINE WILL COMPUTE COLLISION PROBABILITIES    *
*                 INSIDE A GEOMETRY.  ALL SURFACES WILL DISAPPEAR      *
*                 FROM THE SYSTEM USING EXTERNAL BOUNDARY CONDITIONS.  *
*                                                                      *
*--------+-------------- V A R I A B L E S -------------+--+-----------*
*  NAME  /                  DESCRIPTION                 /IO/MOD(DIMENS)*
*--------+----------------------------------------------+--+-----------*
* IPSYS  / POINTER TO THE PIJ (L_PIJ)                   /I./INT        *
* IPTRK  / POINTER TO THE EXCELL TRACKING (L_TRACK)     /I./INT        *
* IFTRAK / UNIT OF THE SEQUENTIAL BINARY TRACKING FILE  /I./INT        *
* IPRNTP / INCREASING OUTPUT ASKED FROM 'EXCELP'        /I./INT        *
* NREGIO / # OF ZONES ACCORDING TO EXCELL GEOMETRY      /I./INT        *
* NBMIX  / NUMBER OF MIXTURES                           /I./INT        *
* MATCOD / MATERIAL #S FOR ZONES IN THE GEOMETRY        /I./INT(NREGIO)*
* VOLUME / VOLUMES OF ZONES IN THE GEOMETRY (NOT USED)  /I./REL(NREGIO)*
* NRENOR / NORMALIZATION SCHEME FOR 'PIJ' MATRIX        /I./INT        *
* NELPIJ / NUMBER OF ELEMENTS IN PIJ MATRIX             /I./INT        *
* IPIJK  / PIJ OPTION   =1 PIJ, =4 PIJK                 /I./INT        *
* LEAKSW / LEAKAGE SWITCH (NOT USED)                    /I./LOGICAL    *
* TITREC / TITLE FOR THIS CASE                          /I./C*72       *
* XSSIGT / TOTAL XS AS INPUT FROM DRAGON.               /I./REL(NBMIX) *
* PIJ    / SYMMETRIC COLLISION PROBABILITIES FOR ZONES  /.O/REL(NELPIJ *
*        / USED IN THE PIJ-MODULE OF DRAGON.            /  /    ,IPIJK)*
* NSBG   / NUMBER OF GROUPS                                            *
* JGL    / Last group processed
* NGROUP / Total number of groups
* IFUITE / Leakage probalility flag
* NALBP  / Number of physical albedos              
* ALBP   / Physical albedos R(0:NALBP,NSBG)
*--------+---------------- R O U T I N E S -------------+--+-----------*
*  NAME  /                  DESCRIPTION                                *
*--------+-------------------------------------------------------------*
* PIJABC / TO ELIMINATE SURFACES USING B.C. OF THE SYSTEM              *
* PIJAAA / TO ELIMINATE SURFACES FOR PIJKS USING B.C. OF THE SYSTEM    *
* PIJI2D / TO INTEGRATE CP IN 2D GEOMETRIES (ISOTROPIC B.C.)           *
* PIJI3D / TO INTEGRATE CP IN 3D GEOMETRIES (ISOTROPIC B.C.)           *
* PIJRDG / TO RENORMALIZE CP USING DIAGONAL COEFFICIENTS               *
* PIJRGL / TO RENORMALIZE CP USING GELBARD HOMOGENEOUS SCHEME          *
* PIJRNL / TO RENORMALIZE CP USING NON-LINEAR FACTORS                  *
* PIJS2D / TO INTEGRATE CP IN 2D GEOMETRIES (SPECULAR  B.C.)           *
* PIJS3D / TO INTEGRATE CP IN 3D GEOMETRIES (SPECULAR  B.C.)           *
* PIJWPR / TO PRINT CP MATRICES IN SUM FORMAT                          *
************************************************************************
      IMPLICIT          NONE
      INTEGER           IOUT, ICPALL, ICPEND, MXGAUS, NSTATE
      PARAMETER       ( IOUT=6, ICPALL=4, ICPEND=3, MXGAUS=64,
     >                  NSTATE=40 )
      CHARACTER         NAMSBR*6
      PARAMETER       ( NAMSBR='EXCELP')
      INTEGER           MKI1, MKI2, MKI3, MKI4, MKI5
      PARAMETER (MKI1=600,MKI2=600,MKI3=600,MKI4=600,MKI5=600)
      INTEGER           IPRNTP, NREGIO, NRENOR, MATCOD(NREGIO),
     >                  IDL,JPSST,JPSVT, STAYIN, GOSOUT,LENGHT,
     >                  NUMERO, MATALB, VOLSUR, SIGTAL, SIGT00,  IPRT,
     >                  IFTRAK,  ISPEC,  KSPEC,   NREG,  NNREG,
     >                  NUNKNO, NCOMNT,   NTRK,   NDIM,  NANGL,   NCOR,
     >                   MXSEG,  IUN,    JUN,  ISIGT,
     >                  LOPATH, SIGANG,     RI,   IVOL,    CIJ,  NALBG,
     >                  WSPACE,   WEIG,    FSP,   LOPT,  NSCRP, NELPIJ,
     >                  IC,       NGSS,    IVV,   JGSS,   IPIJK,
     >                  FFACT,  ILONG,MATRT,ITYPE,IIVOL,ISTATE(NSTATE)
      INTEGER           NPROB,N2PROB,PROB,DPROB,IPRB,IDPRB,KPRB,
     >                  PROBX,DPROBX,IPRBX,IDPRBX
      INTEGER           NBMIX
      INTEGER           NSBG,ISBG,KSBG
      INTEGER           IANG,ITRAK,NBSEG
      REAL              WEIGHT
      INTEGER           ISSIGT,ILSIGA
      REAL              VOLUME(NREGIO), XSSIGT(0:NBMIX,NSBG),ALBEDO(6),
     >                  EXTKOP(NSTATE),PIJ(NELPIJ,IPIJK,NSBG),CUTOF, 
     >                  RCUTOF,
     >                  ASCRP, YGSS,  XGSS(MXGAUS), WGSS(MXGAUS),
     >                  WGSSX(MXGAUS),
     >                  COEF, ANG0
      INTEGER           NPST
      REAL              PROBKS(NPST,NSBG)
      LOGICAL           LEAKSW, SWNZBC, SWVOID, LPIJK
      CHARACTER         TITREC*72, CTRKT*4, COMENT*80
*----
*  Variables to implement PIJSBC
*----
      INTEGER           ILCMUP,ILCMDN
      PARAMETER        (ILCMUP=1,ILCMDN=2)
      INTEGER           JGL,NGROUP,NSOUT,IFUITE
      INTEGER           JPSVF
      CHARACTER         CGRPNM*12
      INTEGER           NALBP
      REAL              ALBP(0:NALBP,NSBG)
      INTEGER           ICODE(6),ISA
C
      INTEGER           JJ,IIU,IIL,MSYM,IKL,III,II,IU,IL,ITEMP,ISOUT,
     >                  IIN,IPSYS,IPTRK
*----
*  Variables for NXT: inline tracking
*----
      DOUBLE PRECISION DZERO,DONE,DTWO
      PARAMETER       (DZERO=0.0D0,DONE=1.0D0,DTWO=2.0D0)
      INTEGER          IEDIMG(NSTATE),NPOINT,NBUCEL,MAXMSH,MAXPIN,
     >                 MXGSUR,MXGREG,MAXMDH,NPLANE,NUCELL(3),IDIR
      CHARACTER        NAMREC*12
      INTEGER          DSV,DNSANG,IUNFLD,DANGLT,DORITR,DWGTRK,DVNOR,
     >                 DLENGT,ICINT,DCINT,IDSUR,IDREG,DCMESH,ICSINT,
     >                 DCSINT,ITPIN,DRAPIN,DGMESH,NCORT
C
      INTEGER          L1, L2, L3, L4, L5
      REAL             PAS1,XLIM1,PAS2,XLIM2,PAS3,XLIM3,
     >                 PAS4,XLIM4,PAS5,XLIM5,BI1,BI2,BI3,BI4,BI5
      COMMON /BICKL1/  BI1(0:MKI1,3),PAS1,XLIM1,L1
      COMMON /BICKL2/  BI2(0:MKI2,3),PAS2,XLIM2,L2
      COMMON /BICKL3/  BI3(0:MKI3,3),PAS3,XLIM3,L3
      COMMON /BICKL4/  BI4(0:MKI4,3),PAS4,XLIM4,L4
      COMMON /BICKL5/  BI5(0:MKI5,3),PAS5,XLIM5,L5
      DOUBLE PRECISION ABSC(3,2)
C
      INTEGER           ID(1)
      REAL              RD
      COMMON            RD(1)
      EQUIVALENCE      (RD(1),ID(1))
*----
*  Data
*----
      CHARACTER        CDIR(4)*1
      SAVE             CDIR
      DATA             CDIR /'X','Y','Z','R'/
C
C RECOVER EXCELL SPECIFIC TRACKING INFORMATION.
C             ALBEDO: SURFACE ALBEDOS (REAL(6))
C             KSPEC : KIND OF PIJ INTEGRATION (0:ISOTROPE,1:SPECULAR)
C             CUTOF : MFP CUTOFF FOR SPECULAR INTEGRATION
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPTRK,'STATE-VECTOR',ISTATE)
      KSPEC=ISTATE(10)
      CALL XDRSET(EXTKOP,NSTATE,0.0)
      CALL LCMGET(IPTRK,'EXCELTRACKOP',EXTKOP)
      CUTOF=EXTKOP(1)
      CALL LCMGET(IPTRK,'ALBEDO',ALBEDO)
      IF(NALBP .GT. 0) THEN
        CALL LCMGET(IPTRK,'ICODE',ICODE)
      ENDIF
C
      IPRT  = IPRNTP
      IF( IPRT.GE.ICPEND ) WRITE(IOUT,'(1X,A72//)') TITREC
      IF(IFTRAK .NE. 0) THEN
        REWIND IFTRAK
        READ(IFTRAK) CTRKT,NCOMNT,NTRK
        IF( CTRKT .NE.'$TRK' ) GO TO 998
        IF( NCOMNT.LT.0      ) GO TO 998
        IF( NTRK  .EQ.0      ) GO TO 998
        DO 10 IC= 1,NCOMNT
           READ(IFTRAK) COMENT
   10   CONTINUE
        READ(IFTRAK) NDIM,ISPEC,NREG,NSOUT,NALBG,NCOR,NANGL,MXSEG
        IF(NREG.NE.NREGIO )THEN
           CALL XABORT(NAMSBR//': TRACKING FILE HAS INVALID # OF ZONES')
        ENDIF
        NCORT=NCOR
      ELSE
        IF(ISTATE(7) .NE. 4) CALL XABORT(NAMSBR//
     >  ': Tracking file required unless NXT: tracking provided')
        NREG=ISTATE(1)
        NSOUT=ISTATE(5)
        ISPEC=ISTATE(9)
        NPOINT=ISTATE(17)
        MXSEG=ISTATE(18)
        NANGL=ISTATE(20)
        CALL LCMSIX(IPTRK,'NXTRecords  ',ILCMUP)
        CALL LCMGET(IPTRK,'G00000001DIM',IEDIMG)
        NDIM=IEDIMG(1)
        NBUCEL=IEDIMG( 5)
        NUCELL(1)=IEDIMG(13)
        NUCELL(2)=IEDIMG(14)
        NUCELL(3)=IEDIMG(15)
        MAXMSH=IEDIMG(16)
        MAXPIN=IEDIMG(19)
        MXGSUR=IEDIMG(24)
        MXGREG=IEDIMG(25)
        NPLANE=1
        NCOR=1
        NCORT=NCOR
        IF(NDIM .EQ.3) NPLANE=1
        NTRK=NANGL*NPLANE*NPOINT**(NDIM-1)
        IF(MXSEG .LE. 1) THEN
          IF(ISPEC .EQ. 0) THEN
            MXSEG=NBUCEL*
     >           ((MAXPIN+1)*(2*MXGREG+2)+MXGSUR+16)
          ELSE
            MXSEG=8*NANGL*NBUCEL*
     >            ((MAXPIN+1)*(2*MXGREG+2)+MXGSUR+16)
          ENDIF
        ENDIF
        MAXMDH=MAX(MAXMSH,IEDIMG(17),IEDIMG(20))
      ENDIF
      NNREG = NREGIO*NREGIO
      NUNKNO= NREG+NSOUT+1
      NPROB = (NUNKNO*(NUNKNO+1))/2
      N2PROB= 2*NUNKNO*NUNKNO
      CALL SETARA( RD, NUNKNO*NSBG, VOLSUR )
      IIVOL=VOLSUR+NSOUT+1
      CALL SETARA( ID, NUNKNO, MATALB )
      IF(IFTRAK .NE. 0) THEN
        READ(IFTRAK) (RD(VOLSUR+JUN),JUN=0,NUNKNO-1)
        READ(IFTRAK) (ID(MATALB+JUN),JUN=0,NUNKNO-1)
        READ(IFTRAK) ( NSCRP,JUN=1,NALBG)
        READ(IFTRAK) ( ASCRP,JUN=1,NALBG)
        READ(IFTRAK) ANG0,(ASCRP,IUN=2,NDIM),
     >               ((ASCRP,IUN=1,NDIM),JUN=2,NANGL)
        READ(IFTRAK) ( ASCRP,JUN=1,NANGL)
      ELSE
        CALL LCMGET(IPTRK,'MATALB      ',ID(MATALB))
        CALL SETARA(RD,2*NUNKNO,DSV)
        CALL LCMGET(IPTRK,'SAreaRvolume',RD(DSV))
        CALL XDRSDB(NUNKNO,RD(VOLSUR),RD(DSV),1)
        DO JJ=0,NSOUT
          RD(VOLSUR+JJ)=RD(VOLSUR+JJ)/4.0
        ENDDO
*----
*  Allocate memory for NXT tracking
*----
        CALL SETARA(RD,2*(MAXMDH+2)*4,DGMESH)
        CALL NXTXYZ(IPTRK ,IPRNTP,NDIM  ,MAXMSH,NUCELL,
     >              ABSC,RD(DGMESH))
*        CALL XDDSET(RD(DGMESH),(MAXMDH+2)*4,DZERO)
*        JJ=2
*        DO IDIR=1,NDIM
*          NAMREC='G00000001SM'//CDIR(IDIR)
*          CALL LCMGET(IPTRK,NAMREC,RD(DGMESH+JJ))
*          JJ=JJ+2*(MAXMDH+2)
*        ENDDO
        IF(ISPEC .EQ. 1) THEN
          CALL SETARA(RD,2*NANGL,DNSANG)
          CALL LCMGET(IPTRK,'TrackingDnsA',RD(DNSANG))
        ENDIF
        CALL SETARA(ID,2*NBUCEL,IUNFLD)
        CALL SETARA(RD,2*NDIM*NANGL,DANGLT)
        CALL SETARA(RD,2*NDIM*(NDIM+1)*NPLANE*NANGL,
     >              DORITR)
        CALL SETARA(RD,2*NANGL,DWGTRK)
        CALL SETARA(RD,2*NREG,DVNOR)
        NAMREC='G00000001CUF'
        CALL LCMGET(IPTRK,NAMREC,ID(IUNFLD))
        CALL LCMGET(IPTRK,'TrackingDirc',RD(DANGLT))
        CALL LCMGET(IPTRK,'TrackingOrig',RD(DORITR))
        CALL LCMGET(IPTRK,'TrackingWgtD',RD(DWGTRK))
        CALL LCMGET(IPTRK,'VTNormalize ',RD(DVNOR))
        CALL SETARA(RD,2*MXSEG,DLENGT)
        CALL SETARA(ID,5*2*(NBUCEL+4),ICINT)
        CALL SETARA(RD,2*2*(NBUCEL+4),DCINT)
        CALL SETARA(ID,MXGSUR,IDSUR)
        CALL SETARA(ID,MXGREG,IDREG)
        CALL SETARA(RD,2*4*(MAXMDH+2),DCMESH)
        CALL SETARA(ID,5*4*(MXGREG+4)*3,ICSINT)
        CALL SETARA(RD,2*4*(MXGREG+4)*3,DCSINT)
        CALL SETARA(ID,3*(MAXPIN),ITPIN)
        CALL SETARA(RD,6*2*(MAXPIN),DRAPIN)
      ENDIF
      CALL SETARA( RD, NUNKNO*NSBG, SIGTAL )
      CALL SETARA( RD, NUNKNO*NSBG, SIGT00 )
C
      SWNZBC= .FALSE.
      SWVOID= .FALSE.
      LPIJK= IPIJK.EQ.4
*----
*  Prepare for multigroup calculation
*----
      KSBG=0
      DO 2000 ISBG=1,NSBG
      JUN   = 0
      IF(ISBG .GT. 1) THEN
        DO 2001 IUN= -NSOUT, NREG
           RD(VOLSUR+JUN+KSBG)= RD(VOLSUR+JUN)
           JUN= JUN+1
 2001   CONTINUE
      ENDIF
      KSBG=KSBG+NUNKNO
 2000 CONTINUE
      KSBG=0
      DO 2002 ISBG=1,NSBG
        IF(NALBP .GT. 0) THEN
          DO ISA=1,6
            IF(ICODE(ISA). GT. 0) THEN
              ALBEDO(ISA)=ALBP(ICODE(ISA),ISBG)
            ENDIF
          ENDDO
        ENDIF
      JUN   = 0
      DO 20 IUN= -NSOUT, NREG
         IF( IUN.LT.0 )THEN
            RD(SIGT00+JUN+KSBG)= 0.0
            RD(SIGTAL+JUN+KSBG)= ALBEDO(-ID(MATALB+JUN))
            SWNZBC= SWNZBC.OR.(RD(SIGTAL+JUN+KSBG).NE.0.0)
         ELSEIF( IUN.EQ.0 )THEN
            RD(SIGT00+JUN+KSBG)= 0.0
            RD(SIGTAL+JUN+KSBG)= 0.0
         ELSE
            RD(SIGT00+JUN+KSBG)= XSSIGT(MATCOD(IUN),ISBG)
            RD(SIGTAL+JUN+KSBG)= XSSIGT(MATCOD(IUN),ISBG)
            IF( RD(SIGTAL+JUN+KSBG).EQ.0.0 )THEN
               SWVOID= .TRUE.
            ELSE
               RD(VOLSUR+JUN+KSBG)= RD(VOLSUR+JUN+KSBG)*
     >                              RD(SIGTAL+JUN+KSBG)
            ENDIF
         ENDIF
         JUN= JUN+1
   20 CONTINUE
      KSBG=KSBG+NUNKNO
 2002 CONTINUE
C
C     CHOOSE ISOTROPIC OR SPECULAR B.C.
      IF( KSPEC.EQ.0 )THEN
         ISIGT = SIGT00
      ELSE
         ISIGT = SIGTAL
      ENDIF
C
      CALL SETARA( RD,  NPROB*NSBG,   PROB )
      CALL SETARA( RD, N2PROB*NSBG,  DPROB )
      CALL XDDSET(RD(DPROB),NUNKNO*NUNKNO*NSBG,0.0D0)
      IF(LPIJK)THEN
        CALL SETARA( RD,  NPROB*NSBG,   PROBX )
        CALL SETARA( RD, N2PROB*NSBG,  DPROBX )
        CALL XDDSET(RD(DPROBX),NUNKNO*NUNKNO*NSBG,0.0D0)
      ENDIF
C
C
      IF(IPRNTP .GE. 1) THEN
        WRITE(IOUT,6010) MXSEG
      ENDIF
      CALL SETARA( ID,  MXSEG, NUMERO )
      CALL SETARA( RD,  MXSEG, LENGHT )
      IF( ISPEC.EQ.0 )THEN
*----
*  Standard tracking
*----
         IF( NDIM.EQ.2 )THEN
           CALL SETARA( RD,  MXSEG, LOPATH )
           DO ITRAK= 1, NTRK
             IF(IFTRAK .NE. 0) THEN
*----
*  Read tracks from file
*----
               READ(IFTRAK)  IANG,NBSEG,WEIGHT,
     >         (ID(NUMERO+IL),IL=0,NBSEG-1),
     >         (RD(LENGHT+IL),IL= 0,NBSEG-1)
             ELSE
*----
*  Generate selected track
*----
               CALL NXTTGS(IPTRK ,IPRNTP,NDIM  ,NANGL ,NPOINT,NTRK  ,
     >                     ITRAK ,MAXMDH,NSOUT ,NREG  ,NUCELL,NBUCEL,
     >                     MXGSUR,MXGREG,MAXPIN,MXSEG ,
     >                     ID(IUNFLD),ID(MATALB),RD(DSV)   ,
     >                     RD(DGMESH),RD(DANGLT),RD(DVNOR) ,
     >                     RD(DLENGT),ID(ICINT) ,RD(DCINT) ,
     >                     RD(DWGTRK),RD(DORITR),ID(IDSUR) ,
     >                     ID(IDREG) ,ID(ITPIN) ,RD(DCMESH),
     >                     RD(DRAPIN),ID(ICSINT),RD(DCSINT),
     >                     NBSEG ,NCORT ,WEIGHT,
     >                     ID(NUMERO),RD(LENGHT))
               IF(NCORT .EQ. 0) GO TO 1005
             ENDIF
*             WRITE(6,*) 'NCORT =',NCORT,NBSEG,WEIGHT
*             WRITE(6,'(5(I10,F20.15))') 
*     >       (ID(NUMERO+II),RD(LENGHT+II),II=0,NBSEG-1)
*----
*  Scan over beginning and end surfaces
*----
             CALL PIJI2D(NREG,NSOUT,NBSEG,NCORT,NSBG,
     >                   SWVOID,RD(ISIGT),WEIGHT,
     >                   RD(LENGHT),ID(NUMERO),
     >                   RD(LOPATH),RD(DPROB),
     >                   MKI1,BI1,PAS1,XLIM1,L1,
     >                   MKI2,BI2,PAS2,XLIM2,L2,
     >                  MKI3,BI3,PAS3,XLIM3,L3)
             IF(LPIJK)THEN
               CALL PIJI2D(NREG,NSOUT,NBSEG,NCORT,NSBG,
     >                     SWVOID,RD(ISIGT),WEIGHT,
     >                     RD(LENGHT),ID(NUMERO),
     >                     RD(LOPATH),RD(DPROBX),
     >                     MKI3,BI3,PAS3,XLIM3,L3,
     >                     MKI4,BI4,PAS4,XLIM4,L4,
     >                     MKI5,BI5,PAS5,XLIM5,L5)
             ENDIF
 1005        CONTINUE
           ENDDO
           CALL RLSARA( RD( LOPATH ) )
         ELSE
           CALL SETARA( RD,  MXSEG, STAYIN )
           CALL SETARA( RD,  MXSEG, GOSOUT )
           DO ITRAK= 1, NTRK
             IF(IFTRAK .NE. 0) THEN
               READ(IFTRAK)  IANG,NBSEG,WEIGHT,
     >         (ID(NUMERO+IL),IL=0,NBSEG-1),
     >         (RD(LENGHT+IL),IL= 0,NBSEG-1)
             ELSE
               CALL NXTTGS(IPTRK ,IPRNTP,NDIM  ,NANGL ,NPOINT,NTRK  ,
     >                     ITRAK ,MAXMDH,NSOUT ,NREG  ,NUCELL,NBUCEL,
     >                     MXGSUR,MXGREG,MAXPIN,MXSEG ,
     >                     ID(IUNFLD),ID(MATALB),RD(DSV)   ,
     >                     RD(DGMESH),RD(DANGLT),RD(DVNOR) ,
     >                     RD(DLENGT),ID(ICINT) ,RD(DCINT) ,
     >                     RD(DWGTRK),RD(DORITR),ID(IDSUR) ,
     >                     ID(IDREG) ,ID(ITPIN) ,RD(DCMESH),
     >                     RD(DRAPIN),ID(ICSINT),RD(DCSINT),
     >                     NBSEG ,NCORT,WEIGHT,
     >                     ID(NUMERO),RD(LENGHT))
               IF(NCORT .EQ. 0) GO TO 1015
             ENDIF
*             WRITE(6,*) 'NCORT =',NCORT,NBSEG,WEIGHT
*             WRITE(6,'(5(I10,F20.15))') 
*     >       (ID(NUMERO+II),RD(LENGHT+II),II=0,NBSEG-1)
             CALL PIJI3D(NREG,NSOUT,NBSEG,NCORT,NSBG,
     >                  SWVOID,RD(ISIGT),WEIGHT,
     >                  RD(LENGHT),ID(NUMERO),
     >                  RD(STAYIN),RD(GOSOUT),RD(DPROB))
 1015        CONTINUE
           ENDDO
           CALL RLSARA( RD( GOSOUT ) )
           CALL RLSARA( RD( STAYIN ) )
           IF(LPIJK)THEN
             CALL XABORT(NAMSBR//': 3D PIJK NOT SUPPORTED')
           ENDIF
         ENDIF
      ELSEIF( ISPEC.EQ.1 )THEN
C
C        CYCLIC  TRACKING
         RCUTOF= CUTOF
         IF( NDIM.EQ.2 )THEN
            IF( ANG0.EQ.0.0 )THEN
               NGSS= NANGL/2
            ELSE
               NGSS= (NANGL+1)/2
            ENDIF
            CALL ALGPT( NGSS,0.0,1.0,XGSS,WGSS)
            CALL SETARA( RD, NGSS*NUNKNO*NSBG, SIGANG )
            CALL SETARA( RD, NGSS*MXSEG , STAYIN )
            CALL SETARA( RD, NGSS*MXSEG , GOSOUT )
            DO 110 JGSS= 1, NGSS
               YGSS= SQRT(1.0 - XGSS(JGSS)**2)
               WGSS(JGSS)= WGSS(JGSS) * YGSS
               XGSS(JGSS)= 1.0/YGSS
               WGSSX(JGSS)= WGSS(JGSS) / (XGSS(JGSS)**2)
               DO 111 ISBG=1,NSBG
               DO 112 IUN= 1,NUNKNO
                 ILSIGA=SIGANG-1+JGSS+NGSS*(IUN-1+(ISBG-1)*NUNKNO)
                 ISSIGT=ISIGT+IUN-1+(ISBG-1)*NUNKNO
                  IF( ID(MATALB+IUN-1).LE.0 )THEN
                     RD(ILSIGA)= RD(ISSIGT)
                  ELSE
                     RD(ILSIGA)= RD(ISSIGT)*XGSS(JGSS)
                  ENDIF
  112          CONTINUE
  111          CONTINUE
  110       CONTINUE
            DO ITRAK= 1, NTRK
              IF(IFTRAK .NE. 0) THEN
                READ(IFTRAK)  IANG,NBSEG,WEIGHT,
     >          (ID(NUMERO+IL),IL=0,NBSEG-1),
     >          (RD(LENGHT+IL),IL= 0,NBSEG-1)
              ELSE
               CALL NXTTGC(IPTRK ,IPRNTP,NDIM  ,NANGL ,NPOINT,NTRK  ,
     >                     ITRAK ,MAXMDH,NSOUT ,NREG  ,NUCELL,NBUCEL,
     >                     MXGSUR,MXGREG,MAXPIN,MXSEG ,
     >                     ID(IUNFLD),ID(MATALB),RD(DSV)   ,
     >                     RD(DGMESH),RD(DANGLT),RD(DVNOR) ,
     >                     RD(DLENGT),ID(ICINT) ,RD(DCINT) ,
     >                     RD(DWGTRK),RD(DORITR),ID(IDSUR) ,
     >                     ID(IDREG) ,ID(ITPIN) ,RD(DCMESH),
     >                     RD(DRAPIN),ID(ICSINT),RD(DCSINT),
     >                     NBSEG ,NCORT,WEIGHT,
     >                     ID(NUMERO),RD(LENGHT))
                IF(NCORT .EQ. 0) GO TO 1025
              ENDIF
              CALL PIJS2D(NREG,NSOUT,NBSEG,NSBG,WEIGHT,
     >                    RCUTOF,NGSS,RD(SIGANG),XGSS,WGSS,
     >                    RD(LENGHT),ID(NUMERO),
     >                    RD(STAYIN),RD(GOSOUT),RD(DPROB))
              IF(LPIJK)THEN
                CALL PIJS2D(NREG,NSOUT,NBSEG,NSBG,WEIGHT,
     >                      RCUTOF,NGSS,RD(SIGANG),XGSS,WGSSX,
     >                      RD(LENGHT),ID(NUMERO),
     >                      RD(STAYIN),RD(GOSOUT),RD(DPROBX))
              ENDIF
 1025         CONTINUE
            ENDDO 
            CALL RLSARA( RD( GOSOUT ))
            CALL RLSARA( RD( STAYIN ))
            CALL RLSARA( RD( SIGANG ))
         ELSE
            CALL SETARA( RD,  MXSEG, STAYIN )
            CALL SETARA( RD,  MXSEG, GOSOUT )
            DO ITRAK= 1, NTRK
              IF(IFTRAK .NE. 0) THEN
                READ(IFTRAK)  IANG,NBSEG,WEIGHT,
     >          (ID(NUMERO+IL),IL=0,NBSEG-1),
     >          (RD(LENGHT+IL),IL= 0,NBSEG-1)
              ELSE
               CALL NXTTGC(IPTRK ,IPRNTP,NDIM  ,NANGL ,NPOINT,NTRK  ,
     >                     ITRAK ,MAXMDH,NSOUT ,NREG  ,NUCELL,NBUCEL,
     >                     MXGSUR,MXGREG,MAXPIN,MXSEG ,
     >                     ID(IUNFLD),ID(MATALB),RD(DSV)   ,
     >                     RD(DGMESH),RD(DANGLT),RD(DVNOR) ,
     >                     RD(DLENGT),ID(ICINT) ,RD(DCINT) ,
     >                     RD(DWGTRK),RD(DORITR),ID(IDSUR) ,
     >                     ID(IDREG) ,ID(ITPIN) ,RD(DCMESH),
     >                     RD(DRAPIN),ID(ICSINT),RD(DCSINT),
     >                     NBSEG ,NCORT,WEIGHT,
     >                     ID(NUMERO),RD(LENGHT))
                IF(NBSEG .EQ. 0) GO TO 1035
              ENDIF
*----
*  Scan over beginning and end surfaces
*----
              CALL PIJS3D(NREG,NSOUT,NBSEG,NSBG,WEIGHT,
     >                    RCUTOF,RD(ISIGT),
     >                    RD(LENGHT),ID(NUMERO),
     >                    RD(STAYIN),RD(GOSOUT),RD(DPROB))
 1035         CONTINUE
            ENDDO 
            CALL RLSARA( RD( GOSOUT ))
            CALL RLSARA( RD( STAYIN ))
         ENDIF
      ENDIF
      IF(IFTRAK .EQ. 0) THEN
        CALL RLSARA(RD(DRAPIN))
        CALL RLSARA(ID(ITPIN))
        CALL RLSARA(RD(DCSINT))
        CALL RLSARA(ID(ICSINT))
        CALL RLSARA(RD(DCMESH))
        CALL RLSARA(ID(IDREG))
        CALL RLSARA(ID(IDSUR))
        CALL RLSARA(RD(DCINT))
        CALL RLSARA(ID(ICINT))
        CALL RLSARA(RD(DLENGT))
        CALL RLSARA(RD(DVNOR))
        CALL RLSARA(RD(DWGTRK))
        CALL RLSARA(RD(DORITR))
        CALL RLSARA(RD(DANGLT))
        CALL RLSARA(ID(IUNFLD))
        IF(ISPEC .EQ. 1) THEN
          CALL RLSARA(RD(DNSANG))
        ENDIF
        CALL RLSARA(RD(DGMESH))
        CALL RLSARA(RD(DSV))
        CALL LCMSIX(IPTRK,'NXTRecords  ',ILCMDN)
      ENDIF
      IPRB=PROB
      IDPRB=DPROB
      IPRBX=PROBX
      IDPRBX=DPROBX
      DO 2050 ISBG=1,NSBG
         CALL PIJCMP( NREG,NSOUT,NCOR,RD(IDPRB),RD(IPRB) )
         IF(LPIJK)THEN
           CALL PIJCMP( NREG,NSOUT,NCOR,RD(IDPRBX),RD(IPRBX) )
         ENDIF
         IPRB=IPRB+NPROB
         IDPRB=IDPRB+N2PROB
         IPRBX=IPRBX+NPROB
         IDPRBX=IDPRBX+N2PROB
 2050 CONTINUE
      CALL RLSARA( RD( LENGHT ) )
      CALL RLSARA( ID( NUMERO ) )
      CALL RLSARA( RD(  DPROB ) )
C
      IF(LPIJK)THEN
        CALL RLSARA( RD( DPROBX ) )
      ENDIF
      IF( KSPEC.EQ.0 )THEN
         IF( NRENOR.EQ.1 )THEN
            CALL SETARA( RD, NUNKNO, RI)
         ELSEIF( NRENOR.EQ.3 )THEN
            CALL SETARA( RD,  NPROB,    CIJ )
            CALL SETARA( RD,  NPROB, WSPACE )
            CALL SETARA( RD, NUNKNO,   WEIG )
            CALL SETARA( RD, NUNKNO,    FSP )
            CALL SETARA( ID, NUNKNO,    IDL )
         ELSEIF( NRENOR .EQ. 0 )THEN
            CALL SETARA( RD, NUNKNO*3, WEIG )
            CALL SETARA( RD, NUNKNO, FSP )
         ENDIF
      ENDIF
      IPRB=PROB
      IPRBX=PROBX
      KSBG=0
      IIVOL=VOLSUR+NSOUT+1
      DO 2060 ISBG=1,NSBG
        ILSIGA=SIGTAL+(ISBG-1)*NUNKNO
C
C     CHARGE VOLUMES IN THE PROB MATRIX
      JUN= 0
      IVOL= NSOUT*(NSOUT+1)/2
      DO 30 IUN= -NSOUT, NREG
         IF( IUN.LE.0 )THEN
            IVOL= IVOL+1
         ELSE
            IVOL= IVOL+JUN
         ENDIF
         IF( RD(IPRB+IVOL-1).NE.0.0 ) THEN
            CALL XABORT(NAMSBR//': UNEXPECTED VALUE IN PROB MATRIX' )
         ENDIF
         RD(IPRB+IVOL-1)= RD(VOLSUR+KSBG+JUN)
         JUN= JUN+1
   30 CONTINUE
C
      IF(LPIJK)THEN
C
C       CHARGE VOLUMES IN THE PROBX MATRIX
        JUN= 0
        IVOL= NSOUT*(NSOUT+1)/2
        DO 31 IUN= -NSOUT, NREG
           IF( IUN.LE.0 )THEN
              IVOL= IVOL+1
C             IN DIRECTION "X" COEF=(2./3.)*(9./8.)
              COEF= 3./4.
           ELSE
              IVOL= IVOL+JUN
              COEF= 2./3.
           ENDIF
           IF( RD(IPRBX+IVOL-1).NE.0.0 )THEN
              CALL XABORT(NAMSBR//': UNEXPECTED VALUE IN PIJX MATRIX' )
           ENDIF
           RD(IPRBX+IVOL-1)= RD(VOLSUR+KSBG+JUN)*COEF
           JUN= JUN+1
   31   CONTINUE
      ENDIF
C
      IF( KSPEC.EQ.0 )THEN
C
C        RENORMALIZE ALL ISOTROPIC PROBS WITH VARIOUS OPTIONS.
         IF( NRENOR.EQ.1 )THEN
C
C           NORMALIZATION USING GELBARD SCHEME
            CALL PIJRGL( IPRT, NREG, NSOUT, RD(ILSIGA), RD(IPRB),
     >                   RD(RI) )
            IF(LPIJK)CALL PIJRGL( IPRT, NREG, NSOUT, RD(ILSIGA),
     >                            RD(IPRBX), RD(RI) )
         ELSEIF( NRENOR.EQ.2 )THEN
C
C           NORMALIZATION WORKING ON DIAGONAL COEFFICIENTS
            CALL PIJRDG( IPRT, NREG, NSOUT, RD(ILSIGA), RD(IPRB) )
            IF(LPIJK)CALL PIJRDG( IPRT, NREG, NSOUT, RD(ILSIGA),
     >                            RD(IPRBX) )
         ELSEIF( NRENOR.EQ.3 )THEN
C
C           NORMALIZATION WORKING ON WEIGHT FACTORS TO KEEP DIAG = 0.0
            CALL PIJRNL( IPRT,  NREG,   NSOUT, RD(ILSIGA), RD(IPRB),
     >                   RD(CIJ), RD(WSPACE), RD(FSP),
     >                   ID(IDL), RD(WEIG) )
            IF(LPIJK)CALL PIJRNL( IPRT,  NREG,   NSOUT, RD(ILSIGA),
     >                            RD(IPRBX), RD(CIJ), RD(WSPACE),
     >                            RD(FSP), ID(IDL), RD(WEIG) )
         ELSEIF( NRENOR .EQ. 0 )THEN
C
C           NORMALIZATION WORKING ON WEIGHT FACTORS ADDITIVE (HELIOS)
            CALL PIJRHL( IPRT, NREG, NSOUT, RD(ILSIGA), RD(IPRB),
     >                RD(FSP), RD(WEIG) )
            IF(LPIJK)CALL PIJRHL( IPRT,  NREG,   NSOUT, RD(ILSIGA),
     >                            RD(IPRBX), RD(FSP), RD(WEIG) )
         ENDIF
         IF( IPRT.GE.ICPALL )THEN
            LOPT= -1
            MSYM=1
            WRITE(IOUT,'(1H )')
            WRITE(IOUT,'(35H   COLLISION PROBABILITIES OUTPUT: ,
     >                   35H *BEFORE* ALBEDO REDUCTION          )')
            CALL PIJWPR(LOPT,NREG,NSOUT,RD(ILSIGA),RD(IPRB),
     >                  RD(IIVOL),MSYM)
C
            IF(LPIJK)THEN
              WRITE(IOUT,'(35H   X-DIRECT. COLL. PROBAB. OUTPUT: ,
     >                     35H *BEFORE* ALBEDO REDUCTION          )')
              CALL PIJWPR(LOPT,NREG,NSOUT,RD(ILSIGA),RD(IPRBX),
     >                    RD(IIVOL),MSYM)
            ENDIF
C
         ENDIF
      ENDIF
      IPRB=IPRB+NPROB
      IPRBX=IPRBX+NPROB
      KSBG=KSBG+NUNKNO
      IIVOL=IIVOL+NUNKNO
 2060 CONTINUE
      IF( KSPEC.EQ.0 )THEN
         IF( NRENOR.EQ.1 )THEN
            CALL RLSARA( RD(    RI ))
         ELSEIF( NRENOR.EQ.3 )THEN
            CALL RLSARA( ID(    IDL ))
            CALL RLSARA( RD(    FSP ))
            CALL RLSARA( RD(   WEIG ))
            CALL RLSARA( RD( WSPACE ))
            CALL RLSARA( RD(    CIJ ))
         ELSEIF( NRENOR .EQ. 0 )THEN
            CALL RLSARA( RD(    FSP ))
            CALL RLSARA( RD(   WEIG ))
         ENDIF
      ENDIF
      IF(LPIJK)THEN
         IPRBX=PROBX
         DO 2070 ISBG=1,NSBG
         IKL=(NSOUT+1)*(NSOUT+2)/2+NSOUT
         III=0
         DO 123 JJ=1,NREG
            IIU=JJ
            IIL=(JJ-1)*NREG+1
            DO 122 II=1,JJ
               III=III+1
               PROBKS(IIL,ISBG)=RD(IPRBX+IKL+III)
               PROBKS(IIU,ISBG)=PROBKS(IIL,ISBG)
               IIU=JJ+II*NREG
               IIL=IIL+1
  122       CONTINUE
            III=III+NSOUT+1
  123    CONTINUE
         IPRBX=IPRBX+NPROB
 2070    CONTINUE
      ENDIF
      IF( KSPEC.EQ.0 )THEN
C
         CALL SETARA( RD,2*NSOUT*NREG , JPSVT )
         CALL SETARA( RD,2*NSOUT*NREG , JPSVF )
         IF( SWNZBC )THEN
C
C        ELIMINATION OF SURFACES FOR PIJ
C
            CALL SETARA( RD, 2*NSOUT*NSOUT , JPSST )
            CALL SETARA( ID,         NSOUT ,   IDL )
            CALL SETARA( ID,         NSOUT , MATRT )
            CALL LCMLEN(IPTRK,'BC-REFL+TRAN',ILONG,ITYPE)
            IF(ILONG.EQ.NSOUT) THEN
              CALL LCMGET(IPTRK,'BC-REFL+TRAN',ID(MATRT))
            ELSE
               WRITE(IOUT,9000) NAMSBR
               DO ISOUT=0,NSOUT-1
                 ID(MATRT+ISOUT)=ISOUT+1
               ENDDO
            ENDIF
            IPRB=PROB
            IPRBX=PROBX
            DO ISBG=1,NSBG
              ILSIGA=SIGTAL+(ISBG-1)*NUNKNO
              CALL PIJABC(NREG,NSOUT,NPROB,RD(ILSIGA),ID(MATRT),
     >                    RD(IPRB),ID(IDL),RD(JPSST),RD(JPSVT))
              IF(IFUITE .GT. -1) THEN
                WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') JGL+ISBG,NGROUP
                CALL LCMSIX(IPSYS,CGRPNM,ILCMUP)
                CALL PIJSBC(IPSYS,NREG,NSOUT,NPROB,1,
     >                     RD(ILSIGA),RD(IPRB),
     >                     RD(JPSVT),RD(JPSVF))
                IFUITE=1
                CALL LCMSIX(IPSYS,CGRPNM,ILCMDN)
              ENDIF
              IF(LPIJK)THEN
C
C        ELIMINATION OF SURFACES FOR PIJX AND CREATION OF PIJXX
C
                 CALL PIJAAA(NREG,NSOUT,RD(ILSIGA),RD(IPRBX),
     >                     RD(JPSVT),PROBKS(1,ISBG))
                 CALL PIJABC(NREG,NSOUT,NPROB,RD(ILSIGA),ID(MATRT),
     >                     RD(IPRBX),ID(IDL),RD(JPSST),RD(JPSVT))
              ENDIF
              IPRB=IPRB+NPROB
              IPRBX=IPRBX+NPROB
            ENDDO
            CALL RLSARA( ID( MATRT ))
            CALL RLSARA( ID(   IDL ))
            CALL RLSARA( RD( JPSST ))
         ELSE
            IF(IFUITE .GT. -1) THEN
              IPRB=PROB
              IPRBX=PROBX
              DO ISBG=1,NSBG
                ILSIGA=SIGTAL+(ISBG-1)*NUNKNO
                WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') JGL+ISBG,NGROUP
                CALL LCMSIX(IPSYS,CGRPNM,ILCMUP)
                CALL PIJSBC(IPSYS,NREG,NSOUT,NPROB,0,
     >                       RD(ILSIGA),RD(IPRB),
     >                       RD(JPSVT),RD(JPSVF))
                IFUITE=1
                CALL LCMSIX(IPSYS,CGRPNM,ILCMDN)
                IPRB=IPRB+NPROB
                IPRBX=IPRBX+NPROB
              ENDDO
           ENDIF
         ENDIF
         CALL RLSARA( RD( JPSVF ))
         CALL RLSARA( RD( JPSVT ))
      ENDIF
      IPRB=PROB
      IPRBX=PROBX
      IF(LPIJK)THEN
        CALL SETARA(RD,4*NNREG,ITEMP)
      ENDIF
      CALL SETARA( RD, NREG,   FFACT )
      IIVOL=VOLSUR+NSOUT+1
      DO 2090 ISBG=1,NSBG
        ILSIGA=SIGTAL+(ISBG-1)*NUNKNO
      IF( IPRT.GE.ICPEND )THEN
         LOPT= +1
         MSYM=1
         WRITE(IOUT,'(1H )')
         WRITE(IOUT,'(35H   COLLISION PROBABILITIES OUTPUT: ,
     >                35H *AFTER* ALBEDO REDUCTION          )')
         CALL PIJWPR( LOPT,NREG,NSOUT,RD(ILSIGA),RD(IPRB),
     >                RD(IIVOL),MSYM)
C
         IF(LPIJK)THEN
           WRITE(IOUT,'(35H   X-DIRECT. COLL. PROBAB. OUTPUT: ,
     >                  35H *AFTER* ALBEDO REDUCTION          )')
           CALL PIJWPR( LOPT,NREG,NSOUT,RD(ILSIGA),RD(IPRBX),
     >                  RD(IIVOL),MSYM)
           WRITE(IOUT,'(35H0 X-DIRECT. COLL. PROBAB." OUTPUT: ,
     >                  35H PIJX"=PIJX+PISX*(1/(1-PSS))*PSJ   )')
           MSYM=0
           CALL PIJWPR( LOPT,NREG,NSOUT,RD(ILSIGA),PROBKS(1,ISBG),
     >                  RD(IIVOL),MSYM)
         ENDIF
C
      ENDIF
C
C     CHARGE PIJ MATRIX IN THE DRAGON SYMMETRIZED FORMAT
C
      DO 160 IIN=1,NREG
         IF(RD(ILSIGA+NSOUT+IIN).EQ.0.0) THEN
            RD(FFACT+IIN-1)=1.0
         ELSE
            RD(FFACT+IIN-1)=1.0/RD(ILSIGA+NSOUT+IIN)
         ENDIF
  160 CONTINUE
      IVV=0
      KPRB=(NSOUT+1)*(NSOUT+2)/2+NSOUT
      DO 180 IUN=1,NREG
         DO 190 JUN=1,IUN
            KPRB=KPRB+1
            IVV=IVV+1
            PIJ(IVV,1,ISBG)=RD(IPRB+KPRB)*RD(FFACT+IUN-1)
     >                                   *RD(FFACT+JUN-1)
  190    CONTINUE
         KPRB=KPRB+NSOUT+1
  180 CONTINUE
C
      IF(LPIJK)THEN
C
C     CHARGE PIJX AND PIJY MATRICES IN THE DRAGON SYMMETRIZED FORMAT
C     ( PIJX=PIJY ), AND PIJZ CALCULATION ( PIJZ=3*PIJ-PIJX-PIJY )
C     AND THE SAME FOR FULL MATRICES OF PIJX", PIJY" AND PIJZ"
C
        KPRB=(NSOUT+1)*(NSOUT+2)/2+NSOUT
        IVV=0
        DO 181 IUN=1,NREG
          IU=IUN
          IL=(IUN-1)*NREG+1
          DO 191 JUN=1,IUN
            KPRB=KPRB+1
            IVV=IVV+1
            PIJ(IVV,2,ISBG)=1.5*RD(IPRBX+KPRB)*RD(FFACT+IUN-1)*
     >                                    RD(FFACT+JUN-1)
            PROBKS(IL,ISBG)=1.5*PROBKS(IL,ISBG)*RD(FFACT+IUN-1)*
     >                                          RD(FFACT+JUN-1)
            IF(IL.NE.IU)PROBKS(IU,ISBG)=1.5*PROBKS(IU,ISBG)*
     >                      RD(FFACT+IUN-1)*RD(FFACT+JUN-1)
            PIJ(IVV,3,ISBG)=PIJ(IVV,2,ISBG)
            PROBKS(NNREG+IL,ISBG)=PROBKS(IL,ISBG)
            PROBKS(NNREG+IU,ISBG)=PROBKS(IU,ISBG)
            PIJ(IVV,4,ISBG)=3*PIJ(IVV,1,ISBG)-PIJ(IVV,2,ISBG)
     >                                       -PIJ(IVV,3,ISBG)
            PROBKS(2*NNREG+IL,ISBG)=3*PIJ(IVV,1,ISBG)
     >      -PROBKS(IL,ISBG)-PROBKS(NNREG+IL,ISBG)
            PROBKS(2*NNREG+IU,ISBG)=3*PIJ(IVV,1,ISBG)
     >      -PROBKS(IU,ISBG)-PROBKS(NNREG+IU,ISBG)
            IU=IUN+JUN*NREG
            IL=IL+1
  191     CONTINUE
          KPRB=KPRB+NSOUT+1
  181   CONTINUE
C
C----
C  COMPUTE PIJ**(-1)*PIJK*
C----
        CALL PIJKST(IPRNTP,NREGIO,PIJ(1,1,ISBG),
     >              PROBKS(1,ISBG),RD(ITEMP))
      ENDIF
      IPRB=IPRB+NPROB
      IPRBX=IPRBX+NPROB
      IIVOL=IIVOL+NUNKNO
 2090 CONTINUE
        CALL RLSARA( RD( FFACT ) )
      IF(LPIJK)THEN
        CALL RLSARA(RD(ITEMP))
        CALL RLSARA( RD( PROBX ) )
      ENDIF
C
      CALL RLSARA( RD( PROB   ) )
      CALL RLSARA( RD( SIGT00 ) )
      CALL RLSARA( RD( SIGTAL ) )
      CALL RLSARA( ID( MATALB ) )
      CALL RLSARA( RD( VOLSUR ) )
C
      RETURN
 6010 FORMAT(' Maximum length of a line =',I10)
  998 WRITE(IOUT,'(30H ECHO = FIRST RECORD DESTROYED      )')
      CALL XABORT(NAMSBR//': PROBLEM WITH THE TRACKING FILE')
 9000 FORMAT(1X,A6,': *** WARNING *** '/
     >       ' REFLECTION/TRANSMISSION MATRIX MISSING'/
     >       ' USE IDENTITY REFLECTION MATRIX')
      END
