*DECK GXSINI
      SUBROUTINE GXSINI(IPMACR,IPRINT,IUGOXS,NBMIX ,NGROUP,NBELEM,
     >                  NEXTMI,NUMMAT,NEXTRE,NUDEPR,NUMREC,LIREAD,
     >                  NFILCN,IFILCN)
C
C---------------------------  GXSINI  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : GXSINI
C       USE      : INITIALIZE GOXS FORMAT READ
C                  ENERGY GROUP INFORMATION STORED ON THE MACROLIB
C       MODIFIED : 91-01-24
C       AUTHOR   : G.MARLEAU
C
C   2- ROUTINE PARAMETERS:
C    INPUT
C       IPMACR   : POINTER TO THE MACROLIB                    I
C       IPRINT   : PRINT LEVEL                                I
C       NBMIX    : MAXIMUM NUMBER OF MIXTURES                 I
C       IUGOXS   : UNIT FOR XS FILE                           I
C       NGROUP   : MAXIMUM NUMBER OF GROUPS                   I
C                  DEFAULT = 1
C       NBELEM   : NUMBER OF MATERIAL TO ADD                  I
C       NEXTMI   : NEXT MATERIAL TO READ                      I
C       NUMMAT   : MAXIMUM NUMBER OF MATERIAL                 I
C       NEXTRE   : NEXT RECORD TO READ                        I
C       NUDEPR   : STARTING DATA SET TO SKIP                  I
C       NUMREC   : LAST DATA SET TO SKIP                      I
C       LIREAD   : READ OPTION                                L
C                  .TRUE.  = FIRST FILE READ
C                  .FALSE. = A FILE HAS ALREADY BEEN READ
C       NFILCN   : DIMENSION OF IFILCN FILE                   I
C    OUTPUT
C       IFILCN   : GOXS FILE INTEGER DATA                     I(NFILCN)
C
C   3- INTERNAL PARAMETERS:
C       MXMULT   : MAX NUMBER OF WORDS FOR CAR*6 = 2          I
C       NFILMD   : MAX NUMBER OF WORDS FOR FILE NAME RECORD   I
C
C---------------------------   GXSINI  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,NFILNA,MXMULT,NFILMD
      CHARACTER   NAMSBR*6,APG*3
      PARAMETER  (IOUT=6,NFILNA=3,MXMULT=2,NFILMD=1+NFILNA*MXMULT,
     >            NAMSBR='GXSINI',APG=' > ')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPMACR,IPRINT,NBMIX,IUGOXS,NGROUP,NBELEM,NEXTMI,
     >            NUMMAT,NEXTRE,NUDEPR,NUMREC,NFILCN
      INTEGER     IFILCN(NFILCN)
      LOGICAL     LIREAD
C----
C  MEMORY ALLOCATION
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
      INTEGER     INAM,IENER
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   CFILNA(NFILNA)*10,FMTRD*5
      INTEGER     IFILID(NFILMD),MULTA6,NFILID,IREC,ITOT,IFILNA,
     >            JFX,JFZ,JVAR,KSETPE,KNAM,IXSENE,IXSEN,NXSERR
C----
C  INITIALIZE MACHINE DEPENDENT PARAMETERS
C----
      CALL GXSDIM(MULTA6,FMTRD)
      NFILID=1+NFILNA*MULTA6
      DO 110 IREC=NUDEPR,NUMREC
        CALL XDREED(IUGOXS,NEXTRE,IFILID,NFILID)
        NEXTRE=NEXTRE+1
        CALL XDREED(IUGOXS,NEXTRE,IFILCN,NFILCN)
        NEXTRE=NEXTRE+1
        IF(IREC .LT. NUMREC) THEN
          NEXTRE=NEXTRE+3*IFILCN(1)+1
        ENDIF
 110  CONTINUE
      IF(NBELEM .EQ. 0) THEN
        ITOT=IFILCN(2)+NEXTMI-1
      ELSE IF(NBELEM .GT. IFILCN(2)) THEN
        WRITE(IOUT,6104) IFILCN(2),NBELEM
        CALL XABORT(NAMSBR//
     >  ': ATTEMPT TO READ MORE MATERIAL ON GOXS THAN EXISTS')
      ELSE
        ITOT=NUMMAT+NEXTMI-1
      ENDIF
      JFZ=0
      DO 170 IFILNA=1,NFILNA
        JFX=JFZ+1
        JFZ=JFZ+MULTA6
        CFILNA(IFILNA)='          '
        WRITE(CFILNA(IFILNA),FMTRD) (IFILID(JVAR),JVAR=JFX,JFZ)
 170  CONTINUE
      IF(LIREAD) THEN
        NGROUP=IFILCN(1)
      ELSE IF(IFILCN(1) .NE. NGROUP) THEN
        CALL XABORT(NAMSBR//
     > ': NUMBER OF GROUP IS TOO SMALL')
      ENDIF
      KSETPE=IFILCN(9)+IFILCN(4)
      KNAM=(IFILCN(2)+KSETPE)*MULTA6+2*NGROUP+1
      CALL SETARA(IBASE,KNAM,INAM)
      CALL XDREED(IUGOXS,NEXTRE,IBASE(INAM),KNAM)
      WRITE(IOUT,6100) (CFILNA(JVAR),JVAR=1,NFILNA),
     >                 IFILCN(1),IFILCN(2),KSETPE,IFILCN(3)
      IF(ITOT .GT. NBMIX) CALL XABORT(NAMSBR//
     >  ': NUMBER OF MIXTURES IS TOO SMALL')
      IF(LIREAD) THEN
        IXSENE=INAM+MULTA6*(KSETPE+IFILCN(2))
        CALL LCMPUT(IPMACR,'AVGVEL',NGROUP,2,IBASE(IXSENE))
        IXSENE=IXSENE+NGROUP
        CALL LCMPUT(IPMACR,'ENERGY',NGROUP+1,2,IBASE(IXSENE))
        CALL SETARA(RBASE,NGROUP+1,IENER)
        CALL LCMGET(IPMACR,'ENERGY',RBASE(IENER))
        IF(IPRINT .GE. 1) THEN
          WRITE(IOUT,6101)
     >         (RBASE(IENER+JVAR-1),APG,JVAR,APG,JVAR=1,NGROUP),
     >          RBASE(IENER+NGROUP)
        ENDIF
        IXSEN=IENER
        NXSERR=0
        IF(RBASE(IXSEN) .LE. 0.0) THEN
          RBASE(IXSEN)=1.0E-5
          NXSERR=NXSERR+1
        ENDIF
        DO 180 JVAR=1,NGROUP
          IF(RBASE(IXSEN+1) .LE. 0.0) THEN
            RBASE(IXSEN+1)=1.0E-5
            NXSERR=NXSERR+1
          ENDIF
          RBASE(IXSEN)=LOG(RBASE(IXSEN)/RBASE(IXSEN+1))
          IXSEN=IXSEN+1
 180    CONTINUE
        IF(NXSERR .GT. 0)THEN
          IF(IPRINT .GE. 1) THEN
            WRITE(IOUT,6103) NXSERR
          ENDIF
        ENDIF
        IF(IPRINT .GE. 1) THEN
          WRITE(IOUT,6102) (JVAR,RBASE(IENER+JVAR-1),JVAR=1,NGROUP)
        ENDIF
        CALL LCMPUT(IPMACR,'DELTAU',NGROUP,2,RBASE(IENER))
        CALL RLSARA(RBASE(IENER))
      ENDIF
      CALL RLSARA(IBASE(INAM))
      RETURN
C----
C  FORMAT
C----
 6100 FORMAT(///30X,'C O N T E N U   G O X S'//
     >' LIBRARY NAME: ',A8/' CREATOR NAME: ',A8/' VERSION NAME: ',A8/
     >4X,I10,' GROUPES'/4X,I10,' MIXTURES '/4X,I10,' X-S TYPES'/
     >4X,I10,' ORDRE LEGENDRE DE DIFFUSION  '//)
 6101 FORMAT(///30X,'E N E R G Y   L I M I T S   G O X S   (EV)'//1P,
     >6(2X,E10.4,A3,I3,A3))
 6102 FORMAT(///30X,'L E T H A R G Y   W I D T H   G O X S   '//1P,
     >6(2X,'U',I3,' = ',E10.4,';'))
 6103 FORMAT(//10X,I10,' ENERGY GROUPS SET TO 1.0E-5 EV FOR LETHARGY ',
     >'CALCULATIONS INSTEAD OF 0.0 (FROM DLC-117/MATXS7A)')
 6104 FORMAT(' NUMBER OF MATERIAL ON GOXS FILE =',I10/
     >       ' NUMBER OF MATERIAL REQUESTED    =',I10)
      END
