*DECK GXSPUT
      SUBROUTINE GXSPUT(IPMACR,IWGOXS,NBMIX ,NGROUP,NANISO,NEXTRI,
     >                  NFILCN,IFILCN,KEXS  ,
     >                  XSGEN ,NIJJ  ,IRNIJJ,XSSCAT,RSCAT )
C
C---------------------------  GXSPUT  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : GXSPUT
C       USE      : TRANSFER INFORMATION FROM THE MACROLIB TO GOXS
C       MODIFIED : 91-01-24
C       AUTHOR   : G.MARLEAU
C
C   2- ROUTINE PARAMETERS:
C    INPUT
C       IPMACR   : POINTER TO THE MACROLIB            I
C       IWGOXS   : UNIT FOR GOXS                      I
C       NBMIX    : NUMBER OF MIXTURES                 I
C       NGROUP   : NUMBER OF ENERGY GROUPS            I
C       NANISO   : ANISOTROPY ORDER                   I
C       NEXTRI   : NEXT RECORD TO WRITE               I
C       NFILCN   : DIMENSION OF IFILCN VECTOR         I
C       IFILCN   : GOXS FILE INTEGER DATA             I(NFILCN)
C       KEXS     : NB PRIMARY+EDIT XS                 I
C    WORK VECTORS
C       XSGEN    : GENERAL XS VECTOR                  R(NBMIX*KEXS)
C       NIJJ     : NUMBER OF SCATT GROUP AND          I(2*NANISO*
C                  FIRST GROUP IN BAND                  NBMIX)
C       IRNIJJ   : TEMPORARY WORK VECTOR FOR NIJJ     I(NBMIX)
C       XSSCAT   : SCATTERING X-S MATRIX              R(NGROUP*
C                                                 NANISO*NBMIX)
C       RSCAT    : TEMPORARY SCAT MATRIX              R(NGROUP*NBMIX)
C
C---------------------------   GXSPUT  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,ILCMUP,ILCMDN,MAXED,NFILNA,MXMULT,NFILMD,NBXG
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,ILCMUP=1,ILCMDN=2,MAXED=50,NFILNA=3,NBXG=7,
     >            MXMULT=2,NFILMD=1+NFILNA*MXMULT,
     >            NAMSBR='GXSPUT')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPMACR,IWGOXS,NBMIX,NGROUP,NANISO,NEXTRI,
     >            NFILCN,KEXS
      INTEGER     IFILCN(NFILCN),NIJJ(NANISO,NBMIX,2),
     >            IRNIJJ(NBMIX)
      REAL        XSGEN(NBMIX*KEXS),XSSCAT(NGROUP*NANISO*NBMIX),
     >            RSCAT(NGROUP*NBMIX)
C----
C  MEMORY ALLOCATION
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
      INTEGER     INAM,IADNAM
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   CGRPNM*12,CANISO*3,FMTRD*5,HVECT(MAXED)*8
      INTEGER     IFILID(NFILMD),IFIL,MULTA6,NFILID,NEDMAC,
     >            NPRXS,LONG,JFX,JFZ,IFILNA,JVAR,KNAM,IMAT,IED,
     >            JADN,JJJJ,JVEL,JEN,ILCMLN,ILCMTY,IIVEL,IXXE,
     >            IMATER,IXSCUR,IEDTXS,IANIS,LENTOT,IRSC,IPOS,
     >            IGROUP,JGROUP
      REAL        VELG1,VELG2,FCTLP1
      DOUBLE PRECISION SQFMAS,XDRCST,NMASS,EVJ
C----
C  DATA
C----
      CHARACTER   CFILNC(NFILNA)*10,CEDNAM(NBXG)*12
      SAVE        CFILNC,CEDNAM
      DATA       (CFILNC(IFIL),IFIL=1,NFILNA)
     >           /'GOXS','DRAGON','EXP 1993'/
      DATA       (CEDNAM(IEDTXS),IEDTXS=1,NBXG)
     >           /'TOTAL       ','ABS         ','NUSIGF      ',
     >            'CHI         ','            ','TRANC       ',
     >            'NFTOT       '/
C----
C  FOR AVERAGED NEUTRON VELOCITY
C  V=SQRT(2*ENER/M)=SQRT(2/M)*SQRT(ENER)
C  SQFMAS=SQRT(2/M) IN CM/S/SQRT(EV) FOR V IN CM/S AND E IN EV
C        =SQRT(2*1.602189E-19(J/EV)* 1.0E4(CM2/M2) /1.67495E-27 (KG))
C        =1383155.30602 CM/S/SQRT(EV)
C----
      EVJ=XDRCST('eV','J')
      NMASS=XDRCST('Neutron mass','kg')
      SQFMAS=SQRT(2.0D4*EVJ/NMASS)
C----
C  INITIALISE INTEGER CONSTANTS
C----
      CALL GXSDIM(MULTA6,FMTRD)
      NFILID=1+NFILNA*MULTA6
      IFILID(NFILID)=MULTA6
      NGROUP=IFILCN(1)
      NBMIX=IFILCN(2)
      NANISO=IFILCN(3)
      NEDMAC=IFILCN(4)
      NPRXS=IFILCN(9)
      LONG=(NPRXS+NEDMAC)*NBMIX
      JFZ=0
      DO 171 IFILNA=1,NFILNA
        JFX=JFZ+1
        JFZ=JFZ+MULTA6
        READ(CFILNC(IFILNA),FMTRD) (IFILID(JVAR),JVAR=JFX,JFZ)
 171  CONTINUE
C----
C  WRITE FILID, IFLICN, ETC
C----
      CALL XDRITE(IWGOXS,NEXTRI,IFILID,NFILID)
      NEXTRI=NEXTRI+1
      CALL XDRITE(IWGOXS,NEXTRI,IFILCN,NFILCN)
      NEXTRI=NEXTRI+1
      KNAM=(IFILCN(2)+NEDMAC+NPRXS)*MULTA6+2*NGROUP+1
      CALL SETARA(IBASE,KNAM,INAM)
      JFZ=INAM-1
      DO 172 IMAT=1,NBMIX
        JFX=JFZ+1
        JFZ=JFZ+MULTA6
        WRITE(CEDNAM(5),'(3HMAT,I3,2H  )') IMAT
        READ(CEDNAM(5),FMTRD) (IBASE(JVAR),JVAR=JFX,JFZ)
 172  CONTINUE
      DO 173 IED=1,NPRXS
        JFX=JFZ+1
        JFZ=JFZ+MULTA6
        READ(CEDNAM(IED),FMTRD) (IBASE(JVAR),JVAR=JFX,JFZ)
 173  CONTINUE
      IF(NEDMAC .GT. 0) THEN
C----
C  TRANSPORT CORRECTION
C----
        JFX=JFZ+1
        JFZ=JFZ+MULTA6
        READ(CEDNAM(6),FMTRD) (IBASE(JVAR),JVAR=JFX,JFZ)
C----
C  NFTOT
C----
        JFX=JFZ+1
        JFZ=JFZ+MULTA6
        READ(CEDNAM(7),FMTRD) (IBASE(JVAR),JVAR=JFX,JFZ)
        IF(NEDMAC .GT. 2) THEN
          CALL SETARA(IBASE,2*NEDMAC,IADNAM)
          CALL LCMGET(IPMACR,'ADDXSNAME',IBASE(IADNAM))
          JADN=IADNAM
          DO 174 IED=1,NEDMAC-2
            JFX=JFZ+1
            JFZ=JFZ+MULTA6
            DO 175 JJJJ=0,1
              IBASE(JFX+JJJJ)=IBASE(JADN+JJJJ)
 175        CONTINUE
            WRITE(HVECT(IED),'(2A4)') (IBASE(JADN+JJJJ),JJJJ=0,1)
            JADN=JADN+2
 174      CONTINUE
          CALL RLSARA(IBASE(IADNAM))
        ENDIF
      ENDIF
      JVEL=JFZ+1
      JEN=JVEL+NGROUP
      CALL LCMLEN(IPMACR,'ENERGY',ILCMLN,ILCMTY)
      IF(ILCMLN .GT. 0) THEN
        CALL LCMGET(IPMACR,'ENERGY',RBASE(JEN))
        CALL LCMLEN(IPMACR,'AVGVEL',ILCMLN,ILCMTY)
        IF(ILCMLN .LE. 0) THEN
          VELG1=SQRT(RBASE(JEN))
          IIVEL=JVEL
          DO 280 IXXE=JEN+1,JEN+NGROUP
            VELG2=SQRT(RBASE(IXXE))
            RBASE(IIVEL)=SQFMAS*SQRT(VELG1*VELG2)
            VELG1=VELG2
            IIVEL=IIVEL+1
 280      CONTINUE
        ELSE
          CALL LCMGET(IPMACR,'AVGVEL',IBASE(JVEL))
        ENDIF
      ENDIF
      CALL XDRITE(IWGOXS,NEXTRI,IBASE(INAM),KNAM)
      NEXTRI=NEXTRI+1
      CALL RLSARA(IBASE(INAM))
      DO 110 IGROUP=1,NGROUP
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGROUP,NGROUP
        CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
        CALL LCMLEN(IPMACR,'TOTAL',ILCMLN,ILCMTY)
        IF(ILCMLN .LE. 0) THEN
          CALL XDRSET(XSGEN,NBMIX,0.0)
        ELSE
          CALL LCMGET(IPMACR,'TOTAL',XSGEN)
        ENDIF
        CALL LCMLEN(IPMACR,'SIGS 0',ILCMLN,ILCMTY)
        IF(ILCMLN .LE. 0) THEN
          CALL XDRSET(XSGEN(NBMIX+1),NBMIX,0.0)
        ELSE
          CALL LCMGET(IPMACR,'SIGS 0',XSGEN(NBMIX+1))
        ENDIF
        DO 131 IMATER=1,NBMIX
          XSGEN(NBMIX+IMATER)=XSGEN(IMATER)-XSGEN(NBMIX+IMATER)
 131    CONTINUE
        IXSCUR=4*NBMIX+1
        CALL LCMLEN(IPMACR,'NUSIGF',ILCMLN,ILCMTY)
        IF(ILCMLN .LE. 0) THEN
          CALL XDRSET(XSGEN(2*NBMIX+1),NBMIX,0.0)
          CALL XDRSET(XSGEN(3*NBMIX+1),NBMIX,0.0)
        ELSE
          CALL LCMGET(IPMACR,'NUSIGF',XSGEN(2*NBMIX+1))
          CALL LCMGET(IPMACR,'CHI',XSGEN(3*NBMIX+1))
        ENDIF
        IXSCUR=4*NBMIX+1
        IF(NEDMAC .GT. 0) THEN
C----
C  TRANSPORT CORRECTION
C----
          CALL LCMLEN(IPMACR,'TRANC',ILCMLN,ILCMTY)
          IF(ILCMLN .LE. 0) THEN
            CALL XDRSET(XSGEN(IXSCUR),NBMIX,0.0)
          ELSE
            CALL LCMGET(IPMACR,'TRANC',XSGEN(IXSCUR))
          ENDIF
          IXSCUR=IXSCUR+NBMIX
C----
C  NFTOT CORRECTION
C----
          CALL LCMLEN(IPMACR,'NFTOT',ILCMLN,ILCMTY)
          IF(ILCMLN .LE. 0) THEN
            CALL XDRSET(XSGEN(IXSCUR),NBMIX,0.0)
          ELSE
            CALL LCMGET(IPMACR,'NFTOT',XSGEN(IXSCUR))
          ENDIF
          IXSCUR=IXSCUR+NBMIX
          DO 121 IEDTXS=1,NEDMAC-2
            CALL LCMLEN(IPMACR,HVECT(IEDTXS),ILCMLN,ILCMTY)
            IF(ILCMLN .LE. 0) THEN
              CALL XDRSET(XSGEN(IXSCUR),NBMIX,0.0)
            ELSE
              CALL LCMGET(IPMACR,HVECT(IEDTXS),XSGEN(IXSCUR))
            ENDIF
            IXSCUR=IXSCUR+NBMIX
 121      CONTINUE
        ENDIF
        CALL XDRITE(IWGOXS,NEXTRI,XSGEN,LONG)
        NEXTRI=NEXTRI+1
        DO 122 IANIS=1,NANISO
          WRITE(CANISO,'(A1,I2)') 'D',IANIS-1
          CALL LCMLEN(IPMACR,'IJJ'//CANISO,ILCMLN,ILCMTY)
          IF(ILCMLN .EQ. 0) THEN
            DO 223 IMATER=1,NBMIX
              NIJJ(IANIS,IMATER,1)=1
              NIJJ(IANIS,IMATER,2)=1
 223        CONTINUE
          ELSE
            CALL LCMGET(IPMACR,'IJJ'//CANISO,IRNIJJ)
            DO 123 IMATER=1,NBMIX
              NIJJ(IANIS,IMATER,2)=IRNIJJ(IMATER)
 123        CONTINUE
            CALL LCMGET(IPMACR,'NJJ'//CANISO,IRNIJJ)
            DO 124 IMATER=1,NBMIX
              NIJJ(IANIS,IMATER,1)=IRNIJJ(IMATER)
 124        CONTINUE
          ENDIF
 122    CONTINUE
        CALL XDRITE(IWGOXS,NEXTRI,NIJJ,2*NANISO*NBMIX)
        NEXTRI=NEXTRI+1
        LENTOT=0
        IRNIJJ(1)=1
        DO 125 IMATER=1,NBMIX-1
          IRNIJJ(IMATER+1)=IRNIJJ(IMATER)
          DO 126 IANIS=1,NANISO
            IRNIJJ(IMATER+1)=IRNIJJ(IMATER+1)+NIJJ(IANIS,IMATER,1)
 126      CONTINUE
 125    CONTINUE
        DO 127 IANIS=1,NANISO
          FCTLP1=FLOAT(2*IANIS-1)
          WRITE(CANISO,'(A1,I2)') 'D',IANIS-1
          CALL LCMLEN(IPMACR,'SCA'//CANISO,ILCMLN,ILCMTY)
          IF(ILCMLN .EQ. 0) THEN
            LENTOT=LENTOT+NBMIX
            DO 228 IMATER=1,NBMIX
              XSSCAT(IRNIJJ(IMATER))=0.0
              IRNIJJ(IMATER)=IRNIJJ(IMATER)+1
 228        CONTINUE
          ELSE
            LENTOT=LENTOT+ILCMLN
            CALL LCMGET(IPMACR,'SCA'//CANISO,RSCAT)
            IRSC=1
            DO 128 IMATER=1,NBMIX
              IPOS=IRNIJJ(IMATER)
              IRNIJJ(IMATER)=IRNIJJ(IMATER)+NIJJ(IANIS,IMATER,1)
              DO 129 JGROUP=1,NIJJ(IANIS,IMATER,1)
                XSSCAT(IPOS)=RSCAT(IRSC)*FCTLP1
                IPOS=IPOS+1
                IRSC=IRSC+1
 129          CONTINUE
 128        CONTINUE
          ENDIF
 127    CONTINUE
        CALL XDRITE(IWGOXS,NEXTRI,XSSCAT,LENTOT)
        NEXTRI=NEXTRI+1
        CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
 110  CONTINUE
      RETURN
      END
