*DECK JPMTRK
      SUBROUTINE JPMTRK (IPTRK,IPGEOM,IMPX,MAXPTS,MAXJ,MAXZ,TITLE,IUOLD,
     1 IAPP,MULTC,IWIGN,IHALT,ILIGN,INORM,IRECT,IQW,JQUA1,JQUA2,CFTRAK,
     2 IFTRAK,ITRAK,IROT,IBPP,JQUAB,MAT,VOL,IDL)
*
*-----------------------------------------------------------------------
*
* RECOVERY OF THE GEOMETRY AND TRACKING FOR JPM MODULES.
*
* GENERAL PARAMETERS:
*  IPTRK  : POINTER TO THE SYBIL TRACKING (L_TRACK SIGNATURE).
*  IPGEOM : POINTER TO THE GEOMETRY (L_GEOM SIGNATURE).
*  IMPX   : PRINT FLAG.
*  MAXPTS : ALLOCATED STORAGE FOR ARRAYS OF DIMENSION NMERGE.
*  MAXJ   : ALLOCATED STORAGE FOR ARRAYS OF DIMENSION IJAT OR IJAS
*           WHERE IJAT IS THE TOTAL NUMBER OF DISTINCT OUT CURRENTS
*           AND IJAS IS THE TOTAL NUMBER IF OUT-CURRENTS LEAVING ALL
*           THE BLOCKS (MERGED OR NOT).
*  MAXZ   : ALLOCATED STORAGE FOR STORING THE TRACKING INFORMATION.
*  TITLE  : CHARACTER*72 TITLE.
*  IUOLD  : =0 ALWAYS RECOMPUTE ALL BLOCK COLLISION PROBABILITIES;
*           =1 TRY TO SAVE CPU TIME BY USING PREVIOUSLY CALCULATED
*              COLLISION PROBABILITIES.
*  IAPP   : TYPE OF IC APPROXIMATION BETWEEN THE BLOCKS.
*  MULTC  : TYPE OF EURYDICE MULTICELL APPROXIMATION.
*  IWIGN  : TYPE OF CYLINDERIZATION.
*  IHALT  : =1: STOP AT THE END OF TRACKING.
*  ILIGN  : ON/OFF FOR TRACK PRINTOUT.
*  INORM  : ON/OFF FOR TRACK NORMALIZATION.
*  IRECT  : ON/OFF FOR USING SYMMETRIES IN SQUARE CELLS.
*  IQW    : TYPE ON QUADRATURES.
*  JQUA1  : 1-D QUADRATURE PARAMETER.
*  JQUA2  : 2-D QUADRATURE PARAMETERS. DIMENSION JQUA2(2)
*  CFTRAK : CHARACTER*12 NAME OF THE TRACKING FILE FOR CLUSTERS.
*  IFTRAK : UNIT NUMBER OF THE TRACKING FILE FOR CLUSTERS.
*  ITRAK  : =1  PERFORM A NEW TRACKING AND BUILD FILE CFTRAK;
*           =0  RECOVER THE TRACKING OF AN EXISTING CFTRAK FILE (OLD);
*           =-1 RECOVER THE TRACKING OF AN EXISTING CFTRAK FILE (MOD).
*  IROT   : =1 USE DIRECT CLUSTER RECONSTRUCTION;
*           =2 USE SURFACE SPLITTING CLUSTER RECONSTRUCTION.
*  IBPP   : TYPE OF IC APPROXIMATION BETWEEN THE MICRO-STRUCTURES.
*  JQUAB  : QUADRATURE PARAMETER FOR MICRO-STRUCTURES IN BIHET.
*
* SCRATCH STORAGE:
*  MAT    : DIMENSION MAT(MAXPTS)
*  VOL    : DIMENSION VOL(MAXPTS)
*  IDL    : DIMENSION IDL(MAXPTS)
*
*---------------------------------------------- A. HEBERT 26/02/87 -----
*
      PARAMETER(NSTATE=40)
      LOGICAL ILK
      CHARACTER TITLE*72,CFTRAK*12
      DIMENSION MAT(*),VOL(*),IDL(*),JQUA2(2),ISTATE(NSTATE)
      INTEGER      IBASE(1)
      COMMON       BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
      CALL SETARA(BASE,MAXJ,IIFR)
      CALL SETARA(BASE,MAXJ,IALB)
      CALL SETARA(BASE,MAXPTS,IINU)
      CALL SETARA(BASE,MAXJ,IMIX)
      CALL SETARA(BASE,MAXJ,IDVX)
      CALL SETARA(BASE,MAXPTS,IIGE)
      CALL SETARA(IBASE,MAXPTS,IISU)
      CALL SETARA(BASE,MAXJ,ICHO)
      CALL JPMGEO(IPTRK,IPGEOM,MAXPTS,MAXJ,MAXZ,IR,ITG,VOL,MAT,ILK,IMPX,
     1 IAPP,MULTC,IWIGN,IHALT,ILIGN,INORM,IRECT,IQW,JQUA1,JQUA2,
     2 IFTRAK,ITRAK,IROT,IBPP,JQUAB,NMBLK,IJAS,BASE(IIFR),BASE(IALB),
     3 NMERGE,IJAT,IJAR,BASE(IINU),BASE(IMIX),BASE(IDVX),NGEN,NPIS,
     4 BASE(IIGE),IBASE(IISU),BASE(ICHO))
      CALL SETARA(IBASE,IJAT,IMU1)
      CALL SETARA(IBASE,IJAT,IIMA)
      CALL SETARA(BASE,NMERGE,IIGAT)
      CALL JPMPRF (IMPX,NMBLK,BASE(IIFR),NMERGE,IJAT,BASE(IINU),
     1 BASE(IMIX),NGEN,BASE(IIGE),IBASE(IISU),IBASE(IMU1),IBASE(IIMA),
     2 BASE(IIGAT))
      CALL RLSARA(BASE(IIGAT))
      CALL LCMPUT(IPTRK,'MU1',IJAT,1,IBASE(IMU1))
      CALL LCMPUT(IPTRK,'IMA',IJAT,1,IBASE(IIMA))
      NICM=IBASE(IIMA+IJAT-1)
      NPSS=0
      DO 11 IKG=1,NGEN
        NCOUR=IBASE(IISU+IKG-1)
        NPSS=NPSS+NCOUR*NCOUR
   11 CONTINUE
      NUN=NMERGE+IJAT
      DO 10 I=1,NMERGE
   10 IDL(I)=I
      IF((IMPX.GT.0).AND.(IUOLD.EQ.1)) THEN
         WRITE (6,'(/29H JPMT: JPM RECOVER OPTION ON.)')
      ELSE IF(IMPX.GT.0) THEN
         WRITE (6,'(/30H JPMT: JPM RECOVER OPTION OFF.)')
      ENDIF
      CALL RLSARA(IBASE(IIMA))
      CALL RLSARA(IBASE(IMU1))
      CALL RLSARA(BASE(ICHO))
      CALL RLSARA(IBASE(IISU))
      CALL RLSARA(BASE(IIGE))
      CALL RLSARA(BASE(IDVX))
      CALL RLSARA(BASE(IMIX))
      CALL RLSARA(BASE(IINU))
      CALL RLSARA(BASE(IALB))
      CALL RLSARA(BASE(IIFR))
*
      IF(IMPX.GT.5) THEN
         I1=1
         DO 20 I=1,(NMERGE-1)/8+1
         I2=I1+7
         IF(I2.GT.NMERGE) I2=NMERGE
         WRITE (6,130) (J,J=I1,I2)
         WRITE (6,140) (MAT(J),J=I1,I2)
         WRITE (6,150) (IDL(J),J=I1,I2)
         WRITE (6,160) (VOL(J),J=I1,I2)
   20    I1=I1+8
      ENDIF
*
* SAVE GENERAL AND JPM-SPECIFIC TRACKING INFORMATION.
      CALL XDISET(ISTATE,NSTATE,0)
      ISTATE(1)=NMERGE
      ISTATE(2)=NUN
      IF(ILK) THEN
         ISTATE(3)=0
      ELSE
         ISTATE(3)=1
      ENDIF
      ISTATE(4)=IR
      ISTATE(5)=NPIS
      ISTATE(6)=1
      ISTATE(7)=ITG
      ISTATE(8)=MAXZ
      ISTATE(9)=MAXJ
      ISTATE(10)=IUOLD
      ISTATE(11)=NMBLK
      ISTATE(12)=NGEN
      ISTATE(13)=IJAT
      ISTATE(14)=IJAS
      ISTATE(15)=IJAR
      ISTATE(16)=NPSS
      ISTATE(17)=NICM
      CALL LCMPUT(IPTRK,'STATE-VECTOR',NSTATE,1,ISTATE)
      CALL LCMPUT(IPTRK,'MATCOD',NMERGE,1,MAT)
      CALL LCMPUT(IPTRK,'VOLUME',NMERGE,2,VOL)
      CALL LCMPUT(IPTRK,'KEYFLX',NMERGE,1,IDL)
      RETURN
*
  130 FORMAT (///11H REGION    ,8(I8,6X,1HI))
  140 FORMAT (   11H MIXTURE   ,8(I8,6X,1HI))
  150 FORMAT (   11H POINTER   ,8(I8,6X,1HI))
  160 FORMAT (   11H VOLUME    ,8(1P,E13.6,2H I))
      END
