*DECK LDRGEO
      LOGICAL FUNCTION LDRGEO(IPGEOM,GEON1,GEON2,IMPX)
*
*-----------------------------------------------------------------------
*
* COMPARE TWO SUB-GEOMETRIES STORED ON LCM (DO NOT COMPARE MIXTURE
* NUMBERS).
*
* INPUT PARAMETERS:
*  IPGEOM  : POINTER TO THE GEOMETRY (L_GEOM SIGNATURE).
*  GEON1   : CHARACTER*12 NAME OF THE FIRST SUB-GEOMETRY.
*  GEON2   : CHARACTER*12 NAME OF THE SECOND SUB-GEOMETRY.
*  IMPX    : PRINT FLAG. IMPX=0 FOR NO PRINT.
*
* OUTPUT PARAMETER:
*  LDRGEO  : =.TRUE. IF THE TWO GEOMETRIES ARE IDENTICAL.
*
*------------------------------------- AUTHOR: A. HEBERT ; 06/12/89 ----
*
      CHARACTER GEON1*(*),GEON2*(*),NAMT*12,GEON3*12,GEON4*12
      COMMON BASE(1)
      INTEGER IBASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
      GEON3=GEON1
      GEON4=GEON2
      DO 100 IORDER=1,2
      LDRGEO=.TRUE.
      CALL LCMLEN(IPGEOM,GEON3,ILON1,ITY1)
      IF (ILON1.EQ.0) CALL XABORT('LDRGEO: UNKNOWN GEOMETRY.')
      CALL LCMSIX(IPGEOM,GEON3,1)
      IFILE=KDROPN('DUMMYCA',0,3,0,0)
      IF (IFILE.LE.0) CALL XABORT('LDRGEO: KDROPN FAILURE.')
      CALL LCMEXP(IPGEOM,0,IFILE,2,1)
      REWIND(IFILE)
      CALL LCMSIX(IPGEOM,' ',2)
      CALL LCMSIX(IPGEOM,GEON4,1)
      READ(IFILE,210) JLEVEL,NAMT,ITY1,ILON1
      IF (JLEVEL.NE.1) CALL XABORT('LDRGEO: INVALID EXPORT FILE.')
      IF (ITY1.EQ.3) ILON1=(ILON1+3)/4
      ILEVEL=1
   10 DO 20 I=1,ILEVEL-JLEVEL
      CALL LCMSIX(IPGEOM,' ',2)
   20 CONTINUE
      ILEVEL=JLEVEL
      CALL LCMLEN(IPGEOM,NAMT,ILON2,ITY2)
      IF (ITY1.EQ.0) THEN
*        DIRECTORY DATA.
         ILEVEL=ILEVEL+1
         IF (ITY2.NE.0) GO TO 70
         CALL LCMSIX(IPGEOM,NAMT,1)
      ELSE
         IF ((ILON1.NE.ILON2).OR.(ITY1.NE.ITY2)) GO TO 70
         CALL SETARA(BASE,ILON1,IAS1)
         CALL SETARA(BASE,ILON2,IAS2)
         CALL LCMGET(IPGEOM,NAMT,BASE(IAS2))
         IF (ITY1.EQ.1) THEN
*           INTEGER DATA.
            READ(IFILE,'(8I10)') (IBASE(IAS1+I-1),I=1,ILON1)
            IF ((NAMT.NE.'MIX').AND.(NAMT.NE.'STATE-VECTOR')) THEN
               DO 30 I=1,ILON1
                 LDRGEO=LDRGEO.AND.
     >                 (IBASE(IAS1+I-1).EQ.IBASE(IAS2+I-1))
 30            CONTINUE
            ENDIF
            IF (NAMT.EQ.'STATE-VECTOR') THEN
               DO 35 I=1,6
                 LDRGEO=LDRGEO.AND.
     >                 (IBASE(IAS1+I-1).EQ.IBASE(IAS2+I-1))
 35            CONTINUE
            ENDIF
         ELSE IF (ITY1.EQ.2) THEN
*           SINGLE PRECISION DATA.
            READ(IFILE,'(5E16.0)') (BASE(IAS1+I-1),I=1,ILON1)
            ZMAX=0.0
            DO 40 I=1,ILON1
   40       ZMAX=MAX(ZMAX,ABS(BASE(IAS1+I-1)),ABS(BASE(IAS2+I-1)))
            IF (ZMAX.EQ.0.0) ZMAX=1.0
            DO 50 I=1,ILON1
            EPS=ABS(BASE(IAS1+I-1)-BASE(IAS2+I-1))/ZMAX
   50       LDRGEO=LDRGEO.AND.(EPS.LT.1.0E-4)
         ELSE IF (ITY1.EQ.3) THEN
*           CHARACTER*4 DATA.
            READ(IFILE,'(20A4)') (BASE(IAS1+I-1),I=1,ILON1)
            DO 60 I=1,ILON1
   60       LDRGEO=LDRGEO.AND.(BASE(IAS1+I-1).EQ.BASE(IAS2+I-1))
         ELSE
            CALL XABORT('LDRGEO: INVALID DATA TYPE.')
         ENDIF
         CALL RLSARA(BASE(IAS2))
         CALL RLSARA(BASE(IAS1))
         IF (.NOT.LDRGEO) GO TO 70
      ENDIF
      READ(IFILE,210,END=80) JLEVEL,NAMT,ITY1,ILON1
      GO TO 10
*
   70 IF (IMPX.GT.0) WRITE (6,200) GEON3,GEON4,NAMT
      LDRGEO=.FALSE.
   80 DO 90 I=1,ILEVEL
      CALL LCMSIX(IPGEOM,' ',2)
   90 CONTINUE
      IRC=KDRCLS(IFILE,2)
      IF (IRC.LT.0) CALL XABORT('LDRGEO: KDRCLS FAILURE.')
      IF(.NOT.LDRGEO) RETURN
      GEON3=GEON2
  100 GEON4=GEON1
      RETURN
*
  200 FORMAT (/34H LDRGEO: COMPARISON OF GEOMETRIES ,A12,5H AND ,A12,
     1 16H --- LCM BLOCK ',A12,15H' IS DIFFERENT.)
  210 FORMAT (1X,I5,3X,A12,1X,2I8)
      END
