*DECK LIBSUB
      SUBROUTINE LIBSUB (MAXISO,IPLIB,IPROC,NGRO,NBISO,NLIB,ISONAM,TN,
     1 MASKI,IPRECI,IMPX,LSHI,MASKJ,SN,NFS,ISONRF,ISHINA,IHLIB,ILLIB,
     2 NTFG,NIR,GIR)
*
*-----------------------------------------------------------------------
*
*Purpose:
* production of an internal library with subgroups.
*
*Copyright:
* Copyright (C) 2003 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert 
*
*Parameters: input
* MAXISO  maximum number of isotopes permitted.
* IPLIB   pointer to the lattice microscopic cross section library
*         (L_LIBRARY signature).
* IPROC   type of microlib processing:
*         =2: perform temperature interpolation and build a
*             temperature-independent draglib;
*         =3: perform temperature interpolation and compute calendf-
*             type mathematical probability tables based on bin-type
*             cross-sections;
*         =4: perform temperature interpolation and compute physical
*             probability tables or slowing-down correlated probability
*             tables.
* NGRO    number of energy groups.
* NBISO   number of isotopes present in the calculation domain.
* NLIB    number of independent libraries
* ISONAM  alias name of isotopes.
* TN      temperature of each isotope.
* MASKI   isotope masks (isotope with index I is process if
*         MASKI(I)=.true.).
* IPRECI  accuracy index for probability tables in CALENDF.
* IMPX    print flag.
*
*Parameters: scratch
* LSHI
* MASKJ
* SN
* NFS
* ISONRF
* ISHINA
* IHLIB
* ILLIB
* NTFG
* NIR
* GIR
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER MAXISO,IPLIB,IPROC,NGRO,NBISO,NLIB,ISONAM(3,NBISO),IPRECI,
     1 IMPX,LSHI(NBISO),NFS(NGRO),ISONRF(3,MAXISO),ISHINA(3,MAXISO),
     2 IHLIB(2,MAXISO,3),ILLIB(MAXISO),NTFG(MAXISO),NIR(MAXISO)
      LOGICAL MASKI(NBISO),MASKJ(NBISO)
      REAL TN(NBISO),SN(NGRO,NBISO),GIR(MAXISO)
*
      CALL XABORT('LIBSUB: SUBGROUP CAPABILITIES ARE NOT AVAILABLE IN '
     1 //'DRAGON VERSION3.')
      RETURN
      END
