*DECK MCI2AC
      SUBROUTINE MCI2AC( NG, NS, NR, FLUX, MASQ, MU, 
     >                   FC, MAXCON, IPRT)
C
*     FC= 0:  LE PARAMETER EST CALCULE EN FONCTION DU FLUX 
*             ET EST APPLIED AU FLUX
*         1:  LE PARAMETER EST CALCULE EN FONCTION DU COURANT 
*             ET EST APPLIED AU COURANT
*         2:  LE PARAMETER EST CALCULE EN FONCTION DU FLUX 
*             ET EST APPLIED AU FLUX ET AU COURANT
*         3:  LE PARAMETER EST CALCULE EN FONCTION DU FLUX ET DU COURANT
*             ET EST APPLIED AU FLUX ET AU COURANT
*         4:  LE PARAMETER EST CALCULE EN FONCTION DU COURANT
*             ET EST APPLIED AU FLUX ET AU COURANT
C
      IMPLICIT  NONE
      INTEGER   NR, NS, NG, IPRT, MASQ(NG), IG, IR, IS, FC, MAXCON
      INTEGER   NSMIN, NSMAX, NAMIN, NAMAX
      REAL      MU
      DOUBLE PRECISION  FLUX(NG,-NS:NR,3)
      DOUBLE PRECISION  DMU, R1, R2 
      DOUBLE PRECISION  DONE, DZERO, NOM, DENOM
      PARAMETER ( DONE=1.0D0, DZERO=0.0D0 )
      DATA NSMIN, NSMAX, NAMIN, NAMAX / 0, 0, 0, 0 /
C
      IF( FC.EQ.0 )THEN
        NSMIN= 1
        NSMAX= NR
        NAMIN= 1
        NAMAX= NR
      ELSEIF( FC.EQ.1 )THEN
        NSMIN= -NS
        NSMAX= -1
        NAMIN= -NS
        NAMAX= -1
      ELSEIF( FC.EQ.2 )THEN
        NSMIN= 1
        NSMAX= NR
        NAMIN= -NS
        NAMAX= NR
      ELSEIF( FC.EQ.3 )THEN
        NSMIN= -NS
        NSMAX= NR
        NAMIN= -NS
        NAMAX= NR
      ELSEIF( FC.EQ.4 )THEN
        NSMIN= -NS
        NSMAX= -1
        NAMIN= -NS
        NAMAX= NR
      ELSE
        CALL XABORT("MCI2A2: FC > 3 OR FC < 0")
      ENDIF
C     MU CALCULATION
      IF( FC.EQ.1) THEN
        DO  3 IG=MAXCON,NG
          NOM   = DZERO
          DENOM = DZERO
            DO  1 IS=-NS,-1
              R1 = FLUX(IG,IS,2) - FLUX(IG,IS,1) 
              R2 = FLUX(IG,IS,3) - FLUX(IG,IS,2) 
              NOM = NOM + R1*(R2-R1)
              DENOM = DENOM + (R2-R1)*(R2-R1)
    1       CONTINUE
            DMU = - NOM / DENOM
            MU  = REAL(DMU)
            IF( DMU.GT.DZERO )THEN
              DO  11 IS=-NS,-1

C             ACCELERATED VALUES FOR PHI(2) ET PHI(3)
                FLUX(IG,IS,3) = FLUX(IG,IS,2) + DMU *
     >                 (FLUX(IG,IS,3) - FLUX(IG,IS,2))            
                FLUX(IG,IS,2) = FLUX(IG,IS,1) + DMU *
     >                 (FLUX(IG,IS,2) - FLUX(IG,IS,1)) 
   11         CONTINUE
            ELSE
              MU= 1.0
            ENDIF
    3   CONTINUE
C     else of FC=1
      ELSE
C
        NOM   = DZERO
        DENOM = DZERO
        DO 40 IR=NSMIN,-1
        DO 40 IG=MAXCON,NG             
           R1 = FLUX(IG,IR,2) - FLUX(IG,IR,1) 
           R2 = FLUX(IG,IR,3) - FLUX(IG,IR,2) 
           NOM = NOM + R1*(R2-R1)
           DENOM = DENOM + (R2-R1)*(R2-R1)
   40   CONTINUE
        DO 41 IR=1,NSMAX
        DO 41 IG=MAXCON,NG             
           R1 = FLUX(IG,IR,2) - FLUX(IG,IR,1) 
           R2 = FLUX(IG,IR,3) - FLUX(IG,IR,2) 
           NOM = NOM + R1*(R2-R1)
           DENOM = DENOM + (R2-R1)*(R2-R1)
   41   CONTINUE
C
        DMU = - NOM / DENOM
C        IF( DMU.LT.DONE .AND. DMU.GT.DZERO ) 
C     >                    DMU= DONE-DMU*0.1D0
C        IF( DMU.GT.DONE ) DMU= DONE+DMU*0.1D0
        MU  = REAL(DMU)
C        IF( DMU.GT.0.9D0 )THEN
        IF( DMU.GT.DZERO )THEN
C        IF( DMU.GT.DONE )THEN
          DO 50 IR=NSMIN,NSMAX
          DO 50 IG=MAXCON,NG             
             FLUX(IG,IR,3) = FLUX(IG,IR,2) + DMU *
     >                       (FLUX(IG,IR,3) - FLUX(IG,IR,2))            
             FLUX(IG,IR,2) = FLUX(IG,IR,1) + DMU *
     >                       (FLUX(IG,IR,2) - FLUX(IG,IR,1)) 
   50     CONTINUE
        ELSE
         MU= 1.0
        ENDIF
C     endif of FC=1, FC=0
      ENDIF
*
      RETURN
      END
