*DECK MOCAGF
      SUBROUTINE MOCAGF(IPFLUX,IAJMOD,NGROUP,NUN,ADJFLO)
*
*---------------------------  MOCAGF  ---------------------------------
*
*  1- PROGRAMME STATISTICS:
* 
*      NAME     :  MOCAGF
*      USE      :  TO INITIALIZE ADJOINT FLUX AND CREATE DIRECTORY 
*                  TO STORE THE ADJOINT FLUX VALUES IN IPFLUX.
*      MODIFIED BY :  MONCHAI A. (10/04/04)   
* 
* 
*  2- ROUTINE PARAMETERS:
*    INPUT
*         IPFLUX : POINTER TO FLUX FILE                    I
*                   
*         NGROUP : INTEGER SCALAR VARIABLE CONTAINING      I
*                  THE NUMBER OF GROUPS.       
*         NUN    : INTEGER SCALAR VARIABLE CONTAINING      I
*                  THE NUMBER OF UNKNOWNS 
*  
*         ADJFLO   REAL ARRAY CONTAINING THE               R(NUN,NGROUP)
*                  MULTIGROUP ADJOINT FLUX
*         IAJMOD  : FLAG FOR TYPE OF ADJOINT CALCULATION   I
*           IAJMOD = 1 ADJOINT FLUX CALCULATION WITHOUT 
*                     EXTERNAL SOURCE
*           IAJMOD = 2 ADJOINT FLUX CALCULATION WITH 
*                     EXTERNAL SOURCE
*    OUTPUT
* 
* --------------------------   MOCAGF    ------------------------------
*
      IMPLICIT NONE
      CHARACTER*12 NAMFLX
      INTEGER      IGROUP,NGROUP,NUN ,IAJMOD,IPFLUX,IOUT
      REAL         ADJFLO(NUN,NGROUP),ONE  ,ZERO  ,TEN
      IOUT=6
      ONE=1.0
      ZERO=0.0
      TEN=10.0
      DO 100 IGROUP=1,NGROUP
        IF(IAJMOD .EQ. 2) THEN
          CALL XDRSET(ADJFLO(1,IGROUP),NUN,ZERO)
        ELSE IF(IAJMOD .EQ. 1) THEN
          CALL XDRSET(ADJFLO(1,IGROUP),NUN,1.0)
        ELSE
          CALL XABORT( 'MOCAGF: INVALID IAJMOD VALUES')
        ENDIF
        WRITE(NAMFLX,'(4HFLUX,I3,1X)') IGROUP
        CALL LCMPUT(IPFLUX,NAMFLX,NUN,2,ADJFLO(1,IGROUP))
 100  CONTINUE
      RETURN
      END
