*DECK MOCANZ
      SUBROUTINE MOCANZ(NGRP,NREG,NFUNL,ADJFLX,ANZFAC)

C---------------------------  MOCANZ  ---------------------------------
C
C 1- PROGRAMME STATISTICS:
C
C     NAME     :  MOCANZ
C     USE      :  ADJOINT FLUX NORMALIZATION TO UNIT PEAK
C     AUTHOR   :  MONCHAI A. (10/04/04)  
C
C 2- ROUTINE PARAMETERS:
C   INPUT
C     NFUNL    : NUMBER OF LEGENDRE ORDER FOR THE FLUX     I
C                (NF=1 FOR CURRENT VERSION)
C     NGRP     : NUMBER OF GROUPS TREATED                  I
C     NREG     : NUMBER OF REGIONS CONSIDERED              I
C        
C  INPUT/OUTPUT
C     ADJFLX   : ADJOINT FLUX ARRAY                      D(NFUNL,NREG,
C                                                          NGRP,8)
C  OUTPUT
C     ANZFAC   : ADJOINT NORMALIZATION FACTOR            D
C---------------------------  MOCANZ  ---------------------------------
      IMPLICIT NONE
      INTEGER            NGRP,NREG,NFUNL
      INTEGER            IGRP,IREG,IOUT
      DOUBLE PRECISION   ADJFLX(NFUNL,NREG,NGRP)
      DOUBLE PRECISION   ANZFAC,MAXFLX
      PARAMETER (IOUT=6 )
      MAXFLX = 0.0D0
      DO 10 IREG= 1, NREG
       DO 20 IGRP= 1, NGRP
          MAXFLX=MAX(MAXFLX,ADJFLX(1,IREG,IGRP))
20     CONTINUE
10    CONTINUE
      IF ( MAXFLX .EQ. 0.0D0 ) THEN
        CALL XABORT('MOCANZ: ZERO MAXFLX ') 
      ENDIF
      ANZFAC = 1.0D0/MAXFLX
      DO 100 IREG= 1, NREG
       DO 200 IGRP= 1, NGRP
          ADJFLX(1,IREG,IGRP) = ADJFLX(1,IREG,IGRP)*ANZFAC
200     CONTINUE
100   CONTINUE
      RETURN
      END