*DECK MOCCOR 
      SUBROUTINE MOCCOR(IPFLUX,IFTRAK,NGRP,NREG,NSOUT, NANIS,NMAT,NGSS,
     >              MXSEG ,NTRK,NFUNL,KEYANI,NIFIS,NL,NBN,
     >              MATALB,VOL,VOLINV,WGSS,XGSS,YGSS,SEGLEN,NRSEG,
     >              EXPT ,EXP2,FLM,FLP,CYP,CYM,SIGANG,NALB,ALBEDO,
     >              XSTOT,XSTRC,XTINV,XSDIA,XSCAT,XSNUF,XSCHI,
     >              FLUX ,ADJFLX,LEAKSW,IPRT,ILEAK,IPMACR,LMODE,
     >              CDIRFL,CADJFL,FLUXO,NTRK2,IFTRK2,NGSS2  )
*  
*---------------------------  MOCCOR  ---------------------------------
* 1- PROGRAMME STATISTICS:
*     NAME     :  MOCCOR
*     USE      :  EVALUATION OF CORRECTION FACTORS CALLED BY SADMCL
*                 AND MOCDRV
*     AUTHOR   :  MONCHAI A. (01/01/06)
*
* 2- ROUTINE PARAMETERS:
*   INPUT
*     ADJFLX   : ADJOINT FLUX ARRAY                      D(NFUNL,NREG,
*                                                          NGRP,8)
*     FLUXO    : GLOBAL DIRECT FLUX ARRAY                R(NUN,NFUNL,
*                FOR MODULE DATA EXCHANGE                  NGRP)
*     IPFLUX   : POINTER TO THE FLUX                     I
*     IPTRK    : POINTER TO THE TRACKING                 I
*     IPMACR   : POINTER TO THE MACROLIB                 I
*     IFTRAK   : FILE UNIT NUMBER FOR TRACKS.            I
*     NGRP     : NUMBER OF GROUPS TREATED                I
*     NMAT     : NUMBER OF MIXTURES CONSIDERED           I
*     NREG     : NUMBER OF REGIONS CONSIDERED            I
*     VOL      : VOLUME OF REGION                        R(NREG)
*     VOLINV   : INVERSE OF VOLUMES                      R(NREG)
*     LEAKSW   : LEAKAGE SWITCH                          L
*     IPRT     : PRINT OPTION FOR CHARACTERISTIC SOLVER  I
*     CDIRFL   : FLUX DIRECTORY NAME                     C*12
*     CADJFL   : ADJOINT FLUX DIRECTORY NAME             C(2)*12
*                FOR STANDARD AND GENERALIZED ADJOINT
*                PROBLEM
*   WORK VECTOR
*     XSSIGT   : GROUP TOTAL CROSS SECTION               R(NMAT+1)
*     XSSIGW   : WITHIN GROUP SCATTERING                 R(NMAT+1)
*
* 3- INTERNAL PARAMETERS:
*     IOUT     : OUTPUT UNIT = 6                         I
*     ILCMUP   : GO UP LCM INDEX = 1                     I
*     ILCMDN   : GO DOWN LCM INDEX = 2                   I
*
*---------------------------   MOCCOR  --------------------------------
*
      IMPLICIT NONE
      REAL        A
      COMMON      A(1)
      INTEGER     I(1)
      EQUIVALENCE (A(1),I(1))
      INTEGER NGRP,NREG,NANIS,NMAT,NGSS,MXSEG,NTRK,NSOUT,MXGAUS,
     >        IPRT,IFTRAK,NFUNL,NL,NBN,IPFLUX,NALB,IPMACR,
     >        NIFIS,NTRK2,IFTRK2,NGSS2,ILEAK
      INTEGER MATALB(-NSOUT:NREG),NRSEG(MXSEG),KEYANI(NFUNL)
      INTEGER IR,IG,JG,IA,IS,ILCMLN,ILCMTY,IOUT,ILCMUP,ILCMDN,
     >        IDUMMY,NUNKNO,IGS,IRS
      PARAMETER(IOUT=6,MXGAUS=64,ILCMUP=1,ILCMDN=2)
      DOUBLE PRECISION  FLM(NGSS,MXSEG),FLP(NGSS,MXSEG),
     >                  CYM(NGSS,MXSEG),CYP(NGSS,MXSEG)
      REAL    SEGLEN(MXSEG),ALBEDO(NALB),FLUXO(NREG,NFUNL,NGRP)
      DOUBLE PRECISION ADJFLX(NFUNL,NREG,NGRP,8),
     >                 FLUX(NFUNL,NREG,NGRP,8)
      LOGICAL LMODE(20),LOWTRK,LEAKSW 
      REAL    EXPT(NGSS,MXSEG),EXP2(NGSS,MXSEG),
     >        SIGANG(NGSS,-NALB:NMAT,NGRP),
     >        XSTOT(0:NMAT,NGRP),XSTRC(0:NMAT,NGRP),XSDIA(0:NMAT,NGRP),
     >        XSCAT(NGRP,0:NMAT,0:NANIS,NGRP),XTINV(0:NMAT,NGRP),
     >        WGSS(MXGAUS),XGSS(MXGAUS),YGSS(MXGAUS),
     >        XSNUF(0:NMAT,NIFIS,NGRP),XSCHI(0:NMAT,NIFIS,NGRP)
      REAL    VOL(NREG),VOLINV(NREG),ONE,ZERO
      DOUBLE PRECISION DONE, DZERO  
      CHARACTER*12 NAMFLX,CDIRFL,CADJFL(2),CCPDIR
      PARAMETER (ZERO=0.0,ONE=1.0,DZERO=0.0D0,DONE=1.0D0)
      LOGICAL  LXSCAT,LEXTSO,LCWDR1,LCWAJ2 
      CCPDIR = 'P_JI DIR    '
      LCWDR1 = .TRUE.
      LCWAJ2 = .FALSE.
      DO 30 JG=1,NGRP
      DO 20 IG=1,NGSS
         DO 13 IR=-NALB,-1
            SIGANG(IG,IR,JG)=ONE-ALBEDO(-IR)
   13    CONTINUE
         SIGANG(IG,0,JG)=ZERO
         DO 11 IR=1,NMAT
            SIGANG(IG,IR,JG)=XSTRC(IR,JG)*YGSS(IG)
   11     CONTINUE
   20 CONTINUE
   30 CONTINUE   
      IF (.NOT.LMODE(4)) RETURN
      LOWTRK=.FALSE. 
      DO 45 IG= 1, NGRP
        CALL MOCRWD(IFTRAK)
        IF( NL.EQ.0 )THEN
            LXSCAT=.FALSE. 
            LEXTSO=.TRUE.
               CALL MOCSWP(NREG,NGRP  ,NL,NMAT,NANIS,NSOUT ,NIFIS,NGSS,
     >                  NALB  ,MXGAUS,IFTRK2 ,IFTRAK,NTRK2 ,NTRK,MXSEG,
     >                  MATALB,NRSEG ,SIGANG ,XSDIA ,XSCAT ,XTINV,
     >                  SEGLEN,ALBEDO,EXPT   ,EXP2  ,WGSS  ,YGSS,NGSS2,
     >                  FLM   ,FLP   ,CYM    ,CYP   ,LXSCAT,LOWTRK,
     >                  VOLINV,LEXTSO,IG   ,NGRP-IG ,IDUMMY,LCWDR1,
     >         FLUX(1,1,1,4),FLUX(1,1,1,8),FLUX(1,1,1,7),FLUX(1,1,1,4))
        ELSE
            CALL XABORT('MOCCOR: ANISOTROPIC OPTION *N/A* YET')
        ENDIF
   45 CONTINUE
      RETURN
      END