*DECK PERGET
      SUBROUTINE PERGET(IPRINT,NAMSAV,ITYPER,LLIN,
     >                  LMOC)
*
*---------------------------  PERGET  ---------------------------------
*
*   1- PROGRAMME STATISTICS:
*       NAME     : PERGET
*       USE      : READ AND ANALYZE DATA FOR PER MODULE
*       AUTHOR   : T. Courau 2000/08/01
*                  M. Assawaroongruengchot 2007/01/01
*
*   2- ROUTINE PARAMETERS:
*      IPRINT  : PRINT SELECTION FOR PER MODULE:                I
*               = 0/1/2/3 NO PRINT/SHORT PRINT/LONG
*      NAMSAV  : NAME OF THE DIRECTORY WHERE THE
*                INFORMATION IS STORED                          C(12)
*      ITYPER  : TYPE OF PERTURBATION CONSIDERED                I
*               = 0 THE REFERENCE FLUX IS USED IN
*                   THE PETURBATION FORMULA
*               = 1 THE PERTURBED FLUX  IS USED IN
*                   THE PETURBATION FORMULA
*               = 2 THE HOMOGENIZED PROPERTIES ARE
*                   COMPUTED DIRECTLY WITH THE PERTURBED FLUX
*      LLIN  : FLAG TO COMPUTE SENSITIVITY COEFFICIENT          L
*               IF (LLIN) 2nd ORDERS TERM ARE NOT COMPUTED IN
*               PERTURBATION FORMULAS
*      LMOC  : FLAG TO USE MOC CALCULATION                      L
*
*---------------------------   PERGET  --------------------------------
*
      IMPLICIT    NONE
      CHARACTER   NAMSBR*6
      PARAMETER  (NAMSBR='PERGET')
*----
*  ROUTINE PARAMETERS
*----
      INTEGER     IPRINT,ITYPER
      LOGICAL     LLIN
      CHARACTER   NAMSAV*12
      LOGICAL     LMOC
*----
*  LOCAL PARAMETERS
*----
      INTEGER     ITYPLU,INTLIR
      CHARACTER   CARLIR*4
      REAL        REALIR
      DOUBLE PRECISION DBLLIR
*---
* INITIALIZE OPTIONS
*---
      IPRINT=1
      NAMSAV='MACROPER'
      ITYPER=0
      LLIN=.FALSE.
      LMOC=.FALSE.
*----
*  READ OPTIONS
*----
 100  CONTINUE
      CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
      IF(ITYPLU .EQ. 10) GO TO 1000
      IF (ITYPLU.NE.3) CALL XABORT(NAMSBR//
     > ': READ ERROR - CHARACTER VARIABLE EXPECTED')
      IF (CARLIR.EQ.'SAVE') THEN
       CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
       IF (ITYPLU.NE.3 .OR. CARLIR(1:2) .NE. 'ON') CALL XABORT(NAMSBR//
     >  ': READ ERROR - CHARACTER ON  EXPECTED AFTER KEYWORD SAVE')
       CALL REDGET(ITYPLU,INTLIR,REALIR,NAMSAV,DBLLIR)
       IF (ITYPLU.NE.3) CALL XABORT(NAMSBR//
     > ': READ ERROR - CHARACTER VARIABLE EXPECTED')
      ELSE IF (CARLIR.EQ.'TYPE') THEN
       CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
       IF (ITYPLU.NE.3)  CALL XABORT(NAMSBR//
     >  ': READ ERROR - CHARACTER KEYWORD EXPECTED AFTER KEYWORD TYPE')
       IF (CARLIR.EQ.'DIR') THEN
         ITYPER=0
       ELSE IF  (CARLIR.EQ.'PER') THEN
         ITYPER=1
       ELSE IF  (CARLIR.EQ.'CALC') THEN
         ITYPER=2
       ELSE
        CALL  XABORT(NAMSBR//': BAD KEYWORD AFTER TYPE')
       ENDIF
      ELSE IF(CARLIR .EQ. 'EDIT') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 1) CALL XABORT(NAMSBR//
     >  ': READ ERROR - EDIT LEVEL EXPECTED')
        IPRINT=INTLIR
      ELSE IF (CARLIR(1:4).EQ.'LIN') THEN
       LLIN=.TRUE.
      ELSE IF (CARLIR(1:4).EQ.'MOC') THEN
       LMOC=.TRUE.
      ELSE IF(CARLIR(1:1) .EQ. ';') THEN
       GO TO 1000
      ELSE
        CALL  XABORT(NAMSBR//': BAD CHARACTER KEYWORD: '//CARLIR)
      ENDIF
      GO TO 100
 1000 CONTINUE
      RETURN
      END
