*DECK QIJRDG
      SUBROUTINE QIJRDG(NREG,NSOUT,NGRP,SIGTAL,PROB,BILAN)
C
C-------------------------    QIJRDG    -------------------------------
C
C 1- SUBROUTINE STATISTICS:
C     NAME     : QIJRDG
C     LEVEL    : 2 (CALLED BY 'XL3')
C     USE      : DIAGONAL NORMALIZATION OF COLLISION PROBS (CP)
C     AUTHOR   : R. ROY (96-04-15)
C     REFERENCE: 'NORMALIZATION TECHNIQUES FOR CP MATRICES',
C                 R.ROY AND G.MARLEAU,
C                 CONF/PHYSOR-90, MARSEILLE/FRANCE, V 2, P IX-40 (1990).
C
C 2- PARAMETERS:
C  INPUT
C     NREG    : # OF ZONES FOR GEOMETRY.             I
C     NSOUT   : # OF SURFACES FOR GEOMETRY.          I
C     NGRP    : # OF ENERGY GROUPS.                  I
C     SIGTAL  : ALBEDO-SIGT VECTOR                   R(NGRP,NSOUT:NREG)
C     PROB    : -CP- MATRIX FOR ALL TYPES.           R(NGRP,NPRB)
C               NPRB=(-NSOUT+NREG+1)*(-NSOUT+NREG+2)/2
C  OUTPUT
C     PROB    : -CP- MATRIX FOR ALL TYPES.           R(NGRP,NPRB)
C  TEMPORARY
C     BILAN   : MULTIGROUP TOTALS.                   R(NGRP)
C
C-------------------------    QIJRDG    -------------------------------
C
      IMPLICIT   NONE
      INTEGER    NREG,NSOUT,NGRP,
     >           IR,JR,IPRB,IPRF,IUNK,JUNK,IVOL,IG
      DOUBLE PRECISION PROB(NGRP,*),BILAN(NGRP)
      REAL       SIGTAL(NGRP,NSOUT:NREG)
      IPRB= 0
      IUNK= 0
      IVOL= -NSOUT*(1-NSOUT)/2
C
C     RENORMALIZE ALL DIAGONAL ELEMENTS OF MATRIX *PROB*
      DO 100 IR = NSOUT, NREG
         IUNK= IUNK+1
         DO 10 IG= 1, NGRP
            BILAN(IG)=0.0D0
   10    CONTINUE
         DO 30 JR= NSOUT, IR-1
            IPRB= IPRB+1
            IF( JR .LT. 0) THEN
               DO 20 IG= 1, NGRP
                  BILAN(IG)=BILAN(IG) + PROB(IG,IPRB)
   20          CONTINUE
            ELSE IF( JR .GT. 0) THEN 
               DO 21 IG= 1, NGRP
                  IF(SIGTAL(IG,JR).GT.0.0 )THEN
                     BILAN(IG)=BILAN(IG) + PROB(IG,IPRB)
                  ENDIF
   21          CONTINUE
            ENDIF
   30    CONTINUE
         IPRB= IPRB+1
         IPRF= IPRB
         JUNK= IUNK
         DO 50 JR=  IR+1 , NREG
            IPRF= IPRF+JUNK
            JUNK= JUNK+1
            IF( JR .LT. 0) THEN
               DO 40 IG= 1, NGRP
                  BILAN(IG)=BILAN(IG) + PROB(IG,IPRF)
   40          CONTINUE
            ELSE IF( JR .GT. 0) THEN 
               DO 41 IG= 1, NGRP
                  IF(SIGTAL(IG,JR).GT.0.0 )THEN
                     BILAN(IG)=BILAN(IG) + PROB(IG,IPRF)
                  ENDIF
   41          CONTINUE
            ENDIF
   50    CONTINUE
         IF( IR.LT.0 )THEN
            IVOL= IVOL+1
            DO 60 IG= 1, NGRP
               PROB(IG,IPRB)= PROB(IG,IVOL)-BILAN(IG)
   60       CONTINUE
         ELSEIF( IR.GT.0 )THEN
            IVOL= IVOL+IUNK-1
C
C              VOIDS ARE NOT TO BE RENORMALIZED
            DO 70 IG= 1, NGRP
               IF( SIGTAL(IG,IR).GT.0.0 )THEN
                  PROB(IG,IPRB)= PROB(IG,IVOL)-BILAN(IG)
               ENDIF
   70       CONTINUE
         ELSE
            IVOL= IVOL+1
         ENDIF
 100  CONTINUE
C
      RETURN
      END
