*DECK SADIDX
      SUBROUTINE SADIDX(IPFLUX,IPLIB ,NGROUP,NIFISS,NNAM  ,
     >                  INAMEA,IXSFL ,INDXRA)
*
*-------------------------    SADIDX   -------------------------------
*
*  1- PROGRAMME STATISTICS:
*      NAME     : SADIDX
*      USE      : Define SAD indices
*      AUTHOR   : G. Marleau
*                 Extracted from SADGAS, SADDTX, etc.
*
*  2- ROUTINE PARAMETERS:
*    INPUT
*      IPFLUX   : POINTER TO THE SOLUTION                I
*      IPLIB    : POINTER TO THE INTERNAL LIBRARY        I
*                 OR MACROLIB
*      NGROUP   : NUMBER OF GROUPS                       I
*      NIFISS   : NUMBER FISSILE ISOTOPES                I
*      NNAM     : NUMBER OF STANDARD XS TREATED          I
*      INAMEA   : NAME OF THE XS TO BE TREATED           I(2,NNAM)
*    INPUT/OUTPUT
*      IXSFL    : FLAG FOR THE XS TO BE TREATED          I(NNAM)
*      INDXRA   : Index for generalized adjoint and      I(NNAM)
*                 and reaction rates 
*
*---------------------------   SADIDX  --------------------------------
*
      IMPLICIT    NONE
      INTEGER     IOUT,NSTATE,ILCMUP,ILCMDN
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,NSTATE=40,ILCMUP=1,ILCMDN=2,
     >            NAMSBR='SADIDX')
*----
*  Routine parameters
*----
      INTEGER     IPFLUX,IPLIB
      INTEGER     NGROUP,NIFISS,NNAM
      INTEGER     INAMEA(2,NNAM)
      INTEGER     IXSFL(NNAM),INDXRA(NNAM)
*----
*  Local parameters
*----
      INTEGER     ISTATE(NSTATE)
      INTEGER     IREAC,ID,ILCMLN,ILCMTY
      CHARACTER   CGRPNM*12,NAMREA*12
*----
*  Update flux state vector
*----
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPFLUX,'STATE-VECTOR',ISTATE)
      ISTATE(20)=NNAM
      CALL LCMPUT(IPFLUX,'STATE-VECTOR',NSTATE,1,ISTATE)
      CALL LCMPUT(IPFLUX,'AdjXSNames  ',2*NNAM,3,INAMEA)   
*----
*  Initialize INDXRA
*----
      INDXRA(1)=2
      INDXRA(2)=14
      INDXRA(3)=INDXRA(2)+NIFISS
      INDXRA(4)=3
      INDXRA(5)=INDXRA(3)+NIFISS
      DO IREAC=6,NNAM
        INDXRA(IREAC)=INDXRA(IREAC-1)+1
      ENDDO
      CALL LCMPUT(IPFLUX,'AdjXSIndex  ',NNAM,1,INDXRA)   
*----
*  Modify IXSFL for cross sections present on macrolib
*----
      WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') 1,NGROUP
      CALL LCMSIX(IPLIB,CGRPNM,ILCMUP)
      DO IREAC=6,NNAM
        ID=INDXRA(IREAC)
        WRITE(NAMREA,'(2A4)') INAMEA(1,IREAC),INAMEA(2,IREAC)
        CALL LCMLEN(IPLIB,NAMREA,ILCMLN,ILCMTY)
        IF(ILCMLN.NE.0) THEN
          IXSFL(IREAC)=ABS(IXSFL(IREAC))
        ENDIF
      ENDDO
      CALL LCMSIX(IPLIB,CGRPNM,ILCMDN)
      IF (NIFISS .GT. 0) THEN
        IXSFL(2)=ABS(IXSFL(2))
        IXSFL(3)=ABS(IXSFL(3))
      ENDIF
      CALL LCMPUT(IPFLUX,'AdjXSProc   ',NNAM,1,IXSFL)   
*----
*  Update flux state vector
*----

      RETURN
      END
