*DECK SADPXS
      SUBROUTINE  SADPXS(IPEDIT,NAMSAV,NGCOND,NMERGE,NL    ,ITRANC,
     >                   NIFISS,NEDMAC,
     >                   NTAUXT,NNAM  ,INAMEA,IXSFL ,INDXRA,
     >                   EIGENK,RATECM,SCATTD,
     >                   SCATC ,IJJ   ,NJJ   ,
     >                   IPOS  ,FACT)
*
*
*---------------------------  SADPXS  ---------------------------------
*
*  1- PROGRAMME STATISTICS:
*      NAME     : SADPXS
*      USE      : PRINT HOMOGENIZED / MERGED XS
*      AUTHOR   : T. COURAU 2000/08/01
*      REMARK   : THIS ROUTINE IS INSPIRED FROM EDIPXS
*
*  2- ROUTINE PARAMETERS:
*    INPUT / OUTPUT
*      IPEDIT   : POINTER TO THE GENERALIZED            I
*                 ADJOINT SOURCES & INTEGRAL PROPERTIES
*      NAMSAV   : NAME OF THE RECORD WHERE
*                 THE HOMOGENIZED XS A PRINTED          C(12)
*      NGCOND   : NUMBER OF GROUPS CONDENSED            I
*      NMERGE   : NUMBER OF REGIONS MERGED              I
*      NL       : NUMBER OF LEGENDRE ORDERS             I
*      ITRANC   : TYPE OF TRANSPORT CORRECTION          I
*      NIFISS   : NUMBER OF FISSILE ISOTOPES            I
*      NEDMAC   : NUMBER OF ADITIONAL EDITION X-S       I
*      NTAUXT   : NUMBER OF REACTION RATE EDITS         I
*      NNAM     : NUMBER OF STANDARD XS TREATED         I
*      INAMEA   : NAME OF THE XS TO BE TREATED          I(2,NNAM)
*      IXSFL    : FLAG FOR THE XS TO BE TREATED         I(NNAM)
*      INDXRA   : Index for generalized adjoint and     I(NNAM)
*                 and reaction rates 
*      EIGENK   : EIGENVALUE FOR PROBLEM                R
*      RATECM   : AVERAGED REGION/GROUP X-S             D(0:NMERGE,
*                 = RATECM(*,1) = FLUXES                  NGCOND,NTAUXT)
*                 = RATECM(*,2) = TOTAL
*                 = RATECM(*,3) = ABS
*                 = RATECM(*,4) = FISSIONS
*                 = RATECM(*,5) = PRODUCTIONS
*                 = RATECM(*,6) = TOTAL LEAKAGES
*                 = RATECM(*,7) = TOTAL OUT OF GROUP SCATTERING
*                 = RATECM(*,8) = DIAGONAL SCATTERING X-S
*                 = RATECM(*,9) = CHI
*                 = RATECM(*,10) = WIMS TYPE TRANSPORT CORRECTION
*                 = RATECM(*,11) = X-DIRECTED LEAKAGES
*                 = RATECM(*,12) = Y-DIRECTED LEAKAGES
*                 = RATECM(*,13) = Z-DIRECTED LEAKAGES
*                 = RATECM(*,*,13+JJ) NUSIGF FOR JJ
*                 = RATECM(*,*,13+NIFISS+JJ) CHI FOR JJ
*                 = RATECM(*,*,13+2*NIFISS+JJ) NFTOT FOR JJ
*                 = RATECM(*,*,13+3*NIFISS+IL) SIGS FOR IL
*                 = RATECM(*,*,13+3*NIFISS+NL+IE) EDIT IE
*                 = RATECM(*,*,NTAUXT)= 1/V MERGE CONDENSED
*      SCATTD   : DOUBLE PRECISION SCATTERING RATES     D(NMERGE,NGCOND,
*                                                         NGCOND,NL)
*    WORK:
*      FACT     : VECTOR STORING THE GROUP XS           R(NMERGE)
*      IJJ      : POSITION OF FIRST DIFFUSION GROUP     I(NMERGE)
*      NJJ      : NUMBER OF DIFFUSION GROUP             I(NMERGE)
*      IPOS     : POSITION OF DIFFUSION GROUP           I(NMERGE)
*      SCATC    : COMPRESS SCATTERING                   R(NMERGE*NGCOND)
*
*  3- INTERNAL PARAMETERS:
*
*      IOUT    : OUTPUT UNIT = 6                    I
*      CGRPNM  : GROUP INDEX NAME FOR LCM           C*12
*
*---------------------------   SADPSA  --------------------------------
*
      IMPLICIT          NONE
      INTEGER           IOUT,ILCMUP,ILCMDN
      CHARACTER         NAMSBR*6
      PARAMETER        (IOUT=6,ILCMUP=1,ILCMDN=2,NAMSBR='SADPXS')
*----
*  ROUTINE PARAMETERS
*----
      INTEGER           IPEDIT
      CHARACTER         NAMSAV*12
      INTEGER           NGCOND,NMERGE,NL,ITRANC,NIFISS,
     >                  NEDMAC,NTAUXT,NNAM
      INTEGER           INAMEA(2,NNAM),IXSFL(NNAM),INDXRA(NNAM)
      INTEGER           IJJ(NMERGE),NJJ(NMERGE),IPOS(NMERGE)
      REAL              EIGENK,SCATC(NMERGE*NGCOND),FACT(NMERGE)
      DOUBLE PRECISION  RATECM(0:NMERGE,NGCOND,NTAUXT),
     >                  SCATTD(NMERGE,NGCOND,NGCOND,NL)
*----
*  LOCAL PARAMETERS
*----
      CHARACTER         CM*2,CGRPNM*12
      INTEGER           INAM,IFIS,IMRG,IGRC,ID,IL,JGRC,IPOSIT,J2,J1
      DOUBLE PRECISION  ACCUMU
      CHARACTER         NAMREA*8
*----
*  Position on required directory
*----
      CALL LCMSIX(IPEDIT,NAMSAV,ILCMUP)
      DO IGRC=1,NGCOND
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGRC,NGCOND
        CALL LCMSIX(IPEDIT,CGRPNM,ILCMUP)
        DO INAM=1,4
*----
*  Scan default XS
*----
          ID=INDXRA(INAM)
          IF(ID.GT.0 .AND. IXSFL(INAM).GE. 1) THEN
            WRITE(NAMREA,'(2A4)') INAMEA(1,INAM),INAMEA(2,INAM)
            IF (INAM .EQ. 1 .OR. INAM .EQ. 4) THEN
*----
*  TOTAL and ABS
*----
              DO IMRG=1,NMERGE
                FACT(IMRG)=REAL(RATECM(IMRG,IGRC,ID)
     >                         /RATECM(IMRG,IGRC,1))
              ENDDO
              CALL LCMPUT(IPEDIT,NAMREA,NMERGE,2,FACT)
            ELSE IF(INAM .EQ. 2) THEN
*----
*  NUSIGF 
*----
              DO IMRG=1,NMERGE
                ACCUMU=0.D0
                DO IFIS=1,NIFISS
                  ACCUMU=ACCUMU+RATECM(IMRG,IGRC,ID-1+IFIS)
                ENDDO
                FACT(IMRG)=REAL(ACCUMU/RATECM(IMRG,IGRC,1))
              ENDDO
              CALL LCMPUT(IPEDIT,NAMREA,NMERGE,2,FACT)
            ELSE IF(INAM.EQ.3) THEN
*----
*  CHI
*----
              CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,9),1)
              CALL LCMPUT(IPEDIT,'CHI',NMERGE,2,FACT)
            ENDIF
          ENDIF
        ENDDO
*----
*  SCATTERING XS PRINTING
*----
        IF(IXSFL(5) .GE. 1) THEN
          IL=1
          WRITE (CM,'(I2)') IL-1
          IPOSIT=0
          DO IMRG=1,NMERGE
            J2=IGRC
            J1=IGRC
            DO JGRC=1,NGCOND
              IF(SCATTD(IMRG,IGRC,JGRC,IL) .NE. 0.0D0) THEN
                J2=MAX(J2,JGRC)
                J1=MIN(J1,JGRC)
              ENDIF
            ENDDO
            NJJ(IMRG)=J2-J1+1
            IJJ(IMRG)=J2
            IPOS(IMRG)=IPOSIT+1
            DO JGRC=J2,J1,-1
              IPOSIT=IPOSIT+1
              SCATC(IPOSIT)=SCATTD(IMRG,IGRC,JGRC,IL)/
     >                             RATECM(IMRG,JGRC,1)
            ENDDO
          ENDDO
          CALL XDRSDB(NMERGE,FACT,SCATTD(1,IGRC,IGRC,IL),1)
          CALL LCMPUT(IPEDIT,'SCAD'//CM,IPOSIT,2,SCATC)
          CALL LCMPUT(IPEDIT,'NJJD'//CM,NMERGE,1,NJJ)
          CALL LCMPUT(IPEDIT,'IJJD'//CM,NMERGE,1,IJJ)
          CALL LCMPUT(IPEDIT,'IPOD'//CM,NMERGE,1,IPOS)
        ENDIF
        DO INAM=6,NNAM
*----
*  Additional XS
*----
          ID=INDXRA(INAM)
          IF(ID.GT.0 .AND. IXSFL(INAM).GE. 1) THEN
            WRITE(NAMREA,'(2A4)') INAMEA(1,INAM),INAMEA(2,INAM)
C---
C TOTAL and ABS
C--
            DO IMRG=1,NMERGE
              FACT(IMRG)=REAL(RATECM(IMRG,IGRC,ID)/RATECM(IMRG,IGRC,1))
            ENDDO
            CALL LCMPUT(IPEDIT,NAMREA,NMERGE,2,FACT)
          ENDIF
        ENDDO
        CALL LCMSIX(IPEDIT,CGRPNM,ILCMDN)
      ENDDO
      CALL LCMPUT(IPEDIT,'K-EFFECTIVE',1,2,EIGENK)
      CALL LCMSIX(IPEDIT,NAMSAV,ILCMDN)
      RETURN
      END
