*DECK SUSGET
      SUBROUTINE SUSGET(IPRINT,IFORM)
*
*-----------------------------------------------------------------------
*
*Purpose:
* To read from the input file the SUS3D: module processing options.
*
*Copyright:
* Copyright (C) 2008 Ecole Polytechnique de Montreal.
*
*Author(s): 
* G. Marleau
*
*Parameters: input/output
* IPRINT  : print level
* IFORM   : SUSD3D flux format
*
*Comments:
* Input data is of the form:
*    [ EDIT iprint ]
*    [ FORMAT { SN | CP } ]
*
*----------
*
      IMPLICIT         NONE
*----
*  Subroutine arguments
*----
      INTEGER          IPRINT,IFORM
*----
*  Local parameters
*----
      INTEGER          IOUT
      CHARACTER        NAMSBR*6
      PARAMETER       (IOUT=6,NAMSBR='SUSGET')
*----
*  Variables for input via REDGET
*----
      INTEGER          ITYPLU,INTLIR
      CHARACTER        CARLIR*72
      REAL             REALIR
      DOUBLE PRECISION DBLLIR
*----
*  Local variables
*----
      INTEGER          IRT,IRMXR
*----
*  Initialize default values for IPRINT
*----
      IPRINT=1
      IFORM=1
*----
*  Get data from input file
*----
 100  CONTINUE
      CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
      IF(ITYPLU .EQ. 10) GO TO 105
      IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >': Read error -- Character variable expected.')
      IF(CARLIR .EQ. ';') THEN
        GO TO 105 
      ELSE IF(CARLIR .EQ. 'EDIT') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 1) CALL XABORT(NAMSBR//
     >  ': Read error -- print level expected after EDIT.')
        IPRINT=INTLIR
      ELSE IF(CARLIR .EQ. 'FORMAT') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >  ': Read error -- Character variable FORMAT expected.')
        IF(CARLIR .EQ. 'CP') THEN
          IFORM=1
        ELSE IF(CARLIR .EQ. 'SN') THEN
          IFORM=0
        ELSE
          CALL XABORT(NAMSBR//': Format '//CARLIR//' is invalid.')
        ENDIF
      ELSE
        CALL XABORT(NAMSBR//': Keyword '//CARLIR//' is invalid.')
      ENDIF
      GO TO 100
 105  CONTINUE
*----
*  Processing finished, return
*----
      RETURN 
      END 
