      SUBROUTINE DRVEQU(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* STANDARD EQUALITY MODULE.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS AND FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =0 CLE-2000 VARIABLE; =1 LINKED LIST; =2 XSM FILE;
*           =3 SEQUENTIAL BINARY FILE; =4 SEQUENTIAL ASCII FILE;
*           =5 DIRECT ACCESS FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
*-------------------------------------- AUTHOR: A. HEBERT ; 02/11/93 ---
*
      CHARACTER HENTRY(*)*12,HSMG*131,TEXT12*12,TEXT4*4
      DOUBLE PRECISION DFLOTT
      LOGICAL LOG
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*)
*
      IMPX=0
   10 CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
      IF(INDIC.EQ.10) GO TO 30
      IF(INDIC.NE.3) CALL XABORT('DRVEQU: CHARACTER DATA EXPECTED.')
      IF(TEXT4.EQ.'EDIT') THEN
         CALL REDGET(INDIC,IMPX,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('DRVEQU: INTEGER DATA EXPECTED.')
      ELSE IF(TEXT4.EQ.';') THEN
         GO TO 30
      ELSE
         CALL XABORT('DRVEQU: '//TEXT4//' IS AN INVALID KEY WORD.')
      ENDIF
      GO TO 10
*
* PARAMETER VALIDATION.
   30 IF(NENTRY.LE.1) CALL XABORT('DRVEQU: PARAMETER EXPECTED.')
      NRHS=0
      NLHS=0
      LOG=.FALSE.
      DO 40 I=1,NENTRY
      IF(JENTRY(I).EQ.0) THEN
         IF(IENTRY(I).EQ.5) CALL XABORT('DRVEQU: THE EQUALITY MODULE '
     1   //'CANNOT WORK WITH DIRECT ACCESS FILES (1).')
         NLHS=NLHS+1
         LOG=LOG.OR.(IENTRY(I).LE.2)
      ELSE IF(JENTRY(I).EQ.2) THEN
         IF(IENTRY(I).EQ.5) CALL XABORT('DRVEQU: THE EQUALITY MODULE '
     1   //'CANNOT WORK WITH DIRECT ACCESS FILES (2).')
         NRHS=NRHS+1
         TEXT12=HENTRY(I)
         ITYPE=IENTRY(I)
         IPLIST=KENTRY(I)
         GO TO 50
      ENDIF
   40 CONTINUE
   50 IF(NLHS.EQ.0) THEN
         CALL XABORT('DRVEQU: NO LHS ENTRY.')
      ELSE IF(NRHS.EQ.0) THEN
         CALL XABORT('DRVEQU: NO RHS ENTRY.')
      ENDIF
*
* RECOVER THE RHS.
      NUNIT=0
      IF(LOG.AND.(ITYPE.LE.2)) THEN
         NUNIT=KDROPN('DUMMYSQ',0,2,0,0)
         IF(NUNIT.LT.0) THEN
            WRITE(HSMG,'(29HDRVEQU: KDROPN FAILURE. IERR=,I3)') NUNIT
            CALL XABORT(HSMG)
         ENDIF
         CALL LCMEXP(IPLIST,0,NUNIT,1,1)
         REWIND(NUNIT)
      ENDIF
*
* CREATE THE LHS.
      DO 60 I=1,NENTRY
      IF(JENTRY(I).EQ.0) THEN
         IF((IENTRY(I).LE.2).AND.(ITYPE.LE.2)) THEN
            CALL LCMEXP(KENTRY(I),0,NUNIT,1,2)
            REWIND(NUNIT)
            IF(IMPX.GT.0) WRITE(6,'(/31H DRVEQU: A LINKED LIST OR XSM F,
     1      11HILE NAMED '',A12,19H'' WAS EQUALLED TO '',A12,2H''.)')
     2      HENTRY(I),TEXT12
         ELSE IF((IENTRY(I).GE.3).AND.(ITYPE.LE.2)) THEN
            CALL LCMEXP(IPLIST,0,KENTRY(I),IENTRY(I)-2,1)
            REWIND(KENTRY(I))
            IF(IMPX.GT.0) WRITE(6,'(/31H DRVEQU: A LINKED LIST OR XSM F,
     1      11HILE NAMED '',A12,24H'' WAS EXPORTED TO FILE '',A12,
     2      2H''.)') TEXT12,HENTRY(I)
         ELSE IF((IENTRY(I).LE.2).AND.(ITYPE.GE.3)) THEN
            CALL LCMEXP(KENTRY(I),0,IPLIST,ITYPE-2,2)
            REWIND(IPLIST)
            IF(IMPX.GT.0) WRITE(6,'(/31H DRVEQU: A LINKED LIST OR XSM F,
     1      11HILE NAMED '',A12,26H'' WAS IMPORTED FROM FILE '',A12,
     2      2H''.)') HENTRY(I),TEXT12
         ELSE IF((IENTRY(I).GE.3).AND.(ITYPE.GE.3)) THEN
            WRITE(HSMG,'(43HDRVEQU: UNABLE TO EQUAL THE TWO SEQUENTIAL ,
     1      7HFILES '',A12,7H'' AND '',A12,2H''.)') HENTRY(I),TEXT12
            CALL XABORT(HSMG)
         ENDIF
      ENDIF
   60 CONTINUE
      IF(NUNIT.GT.0) THEN
         IERR=KDRCLS(NUNIT,2)
         IF(IERR.LT.0) THEN
            WRITE(HSMG,'(29HDRVEQU: KDRCLS FAILURE. IERR=,I3)') IERR
            CALL XABORT(HSMG)
         ENDIF
      ENDIF
      RETURN
      END
