      SUBROUTINE LCMSIX(IPLIST,NAMP,IACT)
*
*----------------------------------------------------------------------
*
* MOVE IN THE HIERARCHICAL STRUCTURE OF A NODE TABLE.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LINKED LIST.
*    NAMP : CHARACTER*12 NAME OF THE DIRECTORY IF IACT=1. NOT USED IF
*           IACT.NE.1.
*    IACT : TYPE OF MOVEMENT IN THE HIERARCHICAL STRUCTURE.
*           0: RETURN TO THE ROOT DIRECTORY;
*           1: MOVE TO A SON DIRECTORY;
*           2: MOVE BACK TO THE PARENT DIRECTORY.
*
* INTERNAL VARIABLES:
*   PNEXT : POINTER TO THE FIRST ELEMENT IN THE ACTIVE LINKED LIST.
*   PFATH : POINTER TO THE FIRST ELEMENT IN THE PARENT LINKED LIST.
*    PDIR : POINTER TO THE DIRECTORY ELEMENT IN THE PARENT LINKED LIST.
*  PNEXT0 : VALUE OF PNEXT AT THE READ-ONLY OPEN TIME.
*  PFATH0 : VALUE OF PFATH AT THE READ-ONLY OPEN TIME.
*   PNEXT : POINTER TO THE NEXT ELEMENT IN THE ACTIVE LINKED LIST.
*   PDATA : POINTER TO THE USEFUL DATA OR TO THE FIRST ELEMENT IN THE
*           SON LINKED LIST.
*
*------------------------------------ AUTHOR: A. HEBERT ; 27/10/93 ----
*
      PARAMETER (MAXEL=40,MAXEXT=70,LHASH=251)
      INTEGER PTMP
      PARAMETER (IHEAD=0,IHNAM=1,INEXT=4,IFATH=5,IDIR=6,IMODE=9)
      PARAMETER (JDATA=LHASH+2,JJLON=LHASH+3,JJTYP=LHASH+4,
     1 JFATH=LHASH+5,JDIR=LHASH+6,JCMT=LHASH+9)
      CHARACTER*(*) NAMP
      CHARACTER NAMT*12,NAMMY*12,HSMG*131
      INTEGER INAMT(3)
      LOGICAL LCATRU,LCAFAL
      PARAMETER (LCATRU=.TRUE.,LCAFAL=.FALSE.)
      COMMON IBASE(1)
*
      IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         CALL XSMSIX(IPLIST,NAMP,IACT)
         RETURN
      ELSE IF(IBASE(IPLIST+IHEAD).NE.100) THEN
         WRITE(HSMG,'(25HLCMSIX: THE LINKED LIST '',3A4,11H'' HAVE THE ,
     1   13HWRONG HEADER.)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(25HLCMSIX: THE LINKED LIST '',3A4,12H'' IS CLOSED.
     1   )') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ENDIF
      IF((IACT.EQ.0).AND.(IBASE(IPLIST+IFATH).EQ.-1)) RETURN
      IPNODE=IBASE(IPLIST+INEXT)
      NAMT=NAMP
      CALL LCMCAR(NAMT,LCATRU,INAMT)
      IF(IACT.EQ.1) THEN
*        MOVE TO A SON DIRECTORY.
*        CHECK IF THE DIRECTORY EXISTS IN THE NODE TABLE.
         IPOS=MOD(ABS(INAMT(1)+3*INAMT(2)+5*INAMT(3)),LHASH)
         DO 10 I=IBASE(IPNODE+2+IPOS),1,-1
         IF(INAMT(1).EQ.IBASE(IPNODE+10*(I-1)+JCMT)) THEN
            IF(INAMT(2).EQ.IBASE(IPNODE+10*(I-1)+JCMT+1)) THEN
               IF(INAMT(3).EQ.IBASE(IPNODE+10*(I-1)+JCMT+2)) THEN
                  IREF=I
                  NEWNOD=IBASE(IPNODE+10*(IREF-1)+JDATA)
                  GO TO 50
               ENDIF
            ENDIF
         ENDIF
   10    CONTINUE
*
*        THE DIRECTORY DOES NOT EXISTS IN THE NODE TABLE.
         IF(IBASE(IPLIST+IMODE).EQ.2) THEN
            PTMP=IBASE(IPLIST+IFATH)
            IF(PTMP.EQ.-1) THEN
             NAMMY='/'
            ELSE
             IP=IBASE(IPLIST+IDIR)
             CALL LCMCAR(NAMMY,LCAFAL,IBASE(PTMP+10*IP+JCMT-10))
            ENDIF
            WRITE(6,'(/26H TRY TO CREATE DIRECTORY '',A12,9H'' FROM DI,
     1      9HRECTORY '',A12,2H''.)') NAMT,NAMMY
            WRITE(HSMG,'(25HLCMSIX: THE LINKED LIST '',3A4,9H'' IS OPEN,
     1      19H IN READ-ONLY MODE.)') (IBASE(IPLIST+IHNAM+I),I=0,2)
            CALL XABORT(HSMG)
         ENDIF
*
*        CREATE A NEW NODE TABLE.
         IREF=IBASE(IPNODE+1)+1
         IF(IREF.GT.IBASE(IPNODE)) THEN
*           INCREASE THE SIZE OF THE NODE TABLE.
            CALL SETARA(IBASE,2+LHASH+10*(IBASE(IPNODE)+MAXEXT),JPNODE)
            IBASE(IPLIST+INEXT)=JPNODE
            IBASE(JPNODE)=IBASE(IPNODE)+MAXEXT
            DO 20 I=2,1+LHASH+10*IBASE(IPNODE)
   20       IBASE(JPNODE+I)=IBASE(IPNODE+I)
            CALL RLSARA(IBASE(IPNODE))
            IPNODE=JPNODE
            IF(IBASE(IPLIST+IFATH).NE.-1) THEN
               JPNODE=IBASE(IPLIST+IFATH)
               JREF=IBASE(IPLIST+IDIR)
               IBASE(JPNODE+10*(JREF-1)+JDATA)=IPNODE
            ENDIF
         ENDIF
         IBASE(IPNODE+2+IPOS)=MAX(IREF,IBASE(IPNODE+2+IPOS))
         IBASE(IPNODE+1)=IREF
         CALL SETARA(IBASE,2+LHASH+10*MAXEL,NEWNOD)
         IBASE(NEWNOD)=MAXEL
         IBASE(NEWNOD+1)=0
         DO 30 I=1,LHASH
   30    IBASE(NEWNOD+1+I)=0
         DO 40 I=1,3
   40    IBASE(IPNODE+10*(IREF-1)+JCMT+I-1)=INAMT(I)
         IBASE(IPNODE+10*(IREF-1)+JDATA)=NEWNOD
         IBASE(IPNODE+10*(IREF-1)+JJLON)=-1
         IBASE(IPNODE+10*(IREF-1)+JJTYP)=0
         IBASE(IPNODE+10*(IREF-1)+JDIR)=IBASE(IPLIST+IDIR)
*
* SWITCH TO THE SON DIRECTORY.
   50    IF((IBASE(IPNODE+10*(IREF-1)+JJLON).NE.-1).OR.(
     1     IBASE(IPNODE+10*(IREF-1)+JJTYP).NE.0)) THEN
           CALL LCMCAR(NAMT,LCAFAL,IBASE(IPNODE+10*IREF+JCMT-10))
           WRITE(HSMG,'(9HLCMSIX: '',A12,24H'' IS AN INVALID DIRECTOR,
     1     21HY TYPE. LINKED LIST='',3A4,2H''.)') NAMT,
     2     (IBASE(IPLIST+IHNAM+I),I=0,2)
           CALL XABORT(HSMG)
         ENDIF
         IBASE(IPNODE+10*(IREF-1)+JFATH)=IBASE(IPLIST+IFATH)
         IBASE(IPLIST+IFATH)=IBASE(IPLIST+INEXT)
         IBASE(IPLIST+IDIR)=IREF
         IBASE(IPLIST+INEXT)=NEWNOD
      ELSE IF((IACT.EQ.0).OR.(IACT.EQ.2)) THEN
*        MOVE BACK TO THE ROOT OR PARENT DIRECTORY.
         IF(IBASE(IPLIST+IFATH).EQ.-1) THEN
            WRITE(HSMG,'(25HLCMSIX: THE LINKED LIST '',3A4,9H'' IS ALRE,
     1      22HADY ON ROOT DIRECTORY.)') (IBASE(IPLIST+IHNAM+I),I=0,2)
            CALL XABORT(HSMG)
         ENDIF
   60    PTMP=IBASE(IPLIST+IFATH)
         IP=IBASE(IPLIST+IDIR)
         IBASE(PTMP+10*(IP-1)+JDATA)=IBASE(IPLIST+INEXT)
         IBASE(IPLIST+INEXT)=IBASE(IPLIST+IFATH)
         IBASE(IPLIST+IFATH)=IBASE(PTMP+10*(IP-1)+JFATH)
         IBASE(IPLIST+IDIR)=IBASE(PTMP+10*(IP-1)+JDIR)
         IF((IACT.EQ.0).AND.(IBASE(IPLIST+IFATH).NE.-1)) GO TO 60
      ELSE
         WRITE(HSMG,'(24HLCMSIX: INVALID ACTION (,I3,15H) ON THE LINKED,
     1   7H LIST '',3A4,2H''.)') IACT,(IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ENDIF
      RETURN
      END
